#!/usr/bin/env python
# -*- coding: iso8859-1 -*-
"""
   OneFinger - main module

   @license: GNU GPL, see COPYING for details
   @copyright: 2004, Maurizio Colucci



   
"""

import sys, os,   pickle, shutil, config, persistence, string, re, signal, time
import kdecore, kdeui
import qt
#import mimetypes
import kio, kfile
from sets import Set
from util import createDirIfNotExisting, find, addSlashIfNeeded, ext, first, forall, remove_ending_slash_if_not_root
from util import exists, best_element
from qt import QMessageBox, QPixmap, QIconSet, QObject, PYSIGNAL, SIGNAL, QVBox, QTimer, QStringList, QWidget, QTabWidget
from qt import QHBox, QMainWindow, QApplication, QString, QTextEdit, QPushButton, QToolBar, QToolButton, QScrollView
from qt import QFrame, Qt, QSizePolicy,  QGrid, QLabel, QToolTip, QUriDrag, QTextDrag, qt_xrootwin, QFont, QPoint, QSize
from my_qt_widgets import FlashingPushButton, FlashingToolButton, MyPopupMenu, FlashingLabel, TruncatingButton, MyListBox, MyLineEdit, MyComboBox, TextItem, TextSeparator, PopupMenuItem, FlashingTextEdit, text_item_button_info, EmptySeparator, HorizListOfButtons, HorizListItem, TruncatingLabel
from dcopexport import DCOPExObj


def _(x):
    return x



#print str(kio.KRecentDocument.recentDocumentDirectory())

listBox = {}
sortBox = {}
label = {}
filterBox = {}
filterButton = {}
filterMenu = {}
filterQuickText = {}
filterClearButton = {}
vbox = {}


selected_files = [] 

files_to_copy = [] # files marked for cut & paste
files_to_move = [] # files marked for cut & paste


widgets_of_selected_files = []

hBox = {}

icon = {}

last_position_of_applet = None # if you close the window list, later
                               # we recreate it in its last position.
                               
program_focused_in_history = None # the history panel needs this
                            # information, because it puts on top the
                            # items used with the last clicked
                            # program.

free_space_in_cur_dir = None

selected_files = [] 

last_tab_selected = -10

selected_actions = []

size_of_big_icons_in_popup_menus = 70.0
size_of_small_icons_in_popup_menus = 28.0

class dragging_state_waiting_for_window:
    def __init__(self, sel_files):
        self.sel_files = sel_files

#QToolTip.setWakeUpDelay(300)

class verb:
    def __init__(self, key):
        assert isinstance(key, str)
        self.key = key

    def forget_this_has_been_used(self):
        del usage_count_of_verb[self.key]
        del last_usage_time_of_verb[self.key]

        
    def name(self):
        return self.key
    def short_name(self):
        return self.key
    def can_manage_type(self, t):
        def prefix_of(s1, s2):
            return s2.find(s1) == 0
        return exists( types_usable_with_verb.get(self.key, Set())
                       , lambda ty: prefix_of(ty, t))
    def works_with_any_file(self):
        return self.key in verbs_that_work_with_any_file
    def icon(self):
        return icon_of_verb[self.key]
    def last_usage_time(self):
        return last_usage_time_of_verb.get(self.key, None)
    def usage_count(self):
        return usage_count_of_verb.get(self.key, 0)
    def arguments_used(self):
        return arguments_of_verb.get(self.key, [])
#     def should_be_greyed(self, selected_files):
#         grey_pred = greyed_condition_of_verb.get(self.key, lambda sel:False)
#         return grey_pred(selected_files)

class mime_program:
    def __init__(self, key):
        assert isinstance(key, str)
        self.key = key

    def forget_this_has_been_used(self):
        del usage_count_of_mime_program[self.key]
        del last_usage_time_of_mime_program[self.key]
        types_used_with_mime_program[self.key] = Set()
        
    def name(self):
        n = readable_name_of_mime_program[self.key]
        g = generic_name_of_mime_program[self.key]
        c = comment_of_mime_program[self.key]
        if len(g)>0:
            n2 = n  + " - " + g 
        else:
            n2 = n
        if len(c)>0:
            n3 = n2  + " (" + c + ")"
        else:
            n3 = n2
        return n3
    def short_name(self):
        return readable_name_of_mime_program[self.key]
    def can_manage_type(self,t):
        return ( t in types_usable_with_mime_program[self.key]
                 or
                 t in types_used_with_mime_program.get(self.key, Set()) )
    def can_manage_some_type(self):
        return ( types_usable_with_mime_program.get(self.key, "-") != "-"
                 or
                 types_used_with_mime_program.get(self.key, "-") != "-" )
    def works_with_any_file(self):
        return False
    def icon(self):
        return icon_of_mime_program[self.key]
    def last_usage_time(self):
        return last_usage_time_of_mime_program.get(self.key, None)
    def usage_count(self):
        return usage_count_of_mime_program.get(self.key, 0)
    def arguments_used(self):
        return arguments_of_mime_program.get(self.key, [])
#     def should_be_greyed(self, selected_files):
#         return False
    def raw_exec_string(self):
        return self.key
    def increase_usage_count(self):
        usage_count_of_mime_program[self.key] = usage_count_of_mime_program.get(
            self.key, 0) +1
    def set_last_usage_time(self, t):
        last_usage_time_of_mime_program[self.key] = t
    def set_arguments_used(self, l):
        arguments_of_mime_program[self.key] = l
    def types_used(self):
        return types_used_with_mime_program.get(self.key, Set())
    def set_types_used(self, set):
        types_used_with_mime_program[self.key] = set

class custom_mime_program:
    def __init__(self,  exec_):
        assert isinstance(exec_, str)
        self.exec_ = exec_
    def forget_this_has_been_used(self):
        del usage_count_of_custom_mime_program[self.exec_]
        del last_usage_time_of_custom_mime_program[self.exec_]
        types_used_with_custom_mime_program[self.exec_] = Set()

    def increase_usage_count(self):
        usage_count_of_custom_mime_program[self.exec_] = usage_count_of_custom_mime_program.get(
            self.exec_, 0) +1
    def set_last_usage_time(self, t):
        last_usage_time_of_custom_mime_program[self.exec_] = t  
    def raw_exec_string(self):
        return self.exec_
    def name(self):
        return readable_name_of_custom_mime_program[self.exec_]
    def short_name(self):
        return readable_name_of_custom_mime_program[self.exec_]
    def can_manage_type(self,t):
        return ( t in types_usable_with_custom_mime_program[self.exec_]
                 or
                 t in types_used_with_custom_mime_program.get(self.exec_, Set()) )
    def works_with_any_file(self):
        return False
    def icon(self):
        print "splitting " + self.exec_
        l = string.split(self.exec_)
        p = l[0]
        return icon_of_cli_program.get(p, QPixmap())
    def last_usage_time(self):
        return last_usage_time_of_custom_mime_program.get(self.exec_, None)
    def usage_count(self):
        return usage_count_of_custom_mime_program.get(self.exec_, 0)
    def arguments_used(self):
        return arguments_of_custom_mime_program.get(self.exec_, [])
    def set_arguments_used(self, l):
        arguments_of_custom_mime_program[self.exec_] = l
#     def should_be_greyed(self, selected_files):
#         return False
    def types_used(self):
        return types_used_with_custom_mime_program.get(self.exec_, Set())
    def set_types_used(self, set):
        types_used_with_custom_mime_program[self.exec_] = set

class cli_program:
    def __init__(self, key):
        self.key = key

    def raw_exec_string(self):
        return self.key


    def forget_this_has_been_used(self):
        del usage_count_of_cli_program[self.key]
        del last_usage_time_of_cli_program[self.key]
        types_used_with_cli_program[self.key] = Set()

    def name(self):
        return self.key
    def short_name(self):
        return self.key
    def can_manage_type(self,t):
        return (t in types_usable_with_cli_program.get(self.key, Set())
                or
                t in types_used_with_cli_program.get(self.key, Set()))
    def can_manage_some_type(self):
        return ( types_usable_with_cli_program.get(self.key, "-") != "-"
                 or
                 types_used_with_cli_program.get(self.key, "-") != "-" )
    def works_with_any_file(self):
        return self.key in cli_programs_that_work_with_any_file
    def icon(self):
        return  QPixmap() #icon_of_cli_program.get(self.key, QPixmap())
    def last_usage_time(self):
        return last_usage_time_of_cli_program.get(self.key, None)
    def usage_count(self):
        return usage_count_of_cli_program.get(self.key, 0)
    def arguments_used(self):
        return arguments_of_cli_program.get(self.key, [])
#     def should_be_greyed(self, selected_files):
#         return False


files_selected_in_the_history_panel = Set() # we need to remember what
                                            # files were selected in
                                            # the history panel

dragging_state = "no-drag"
cli_programs_that_work_with_any_file = Set(['mv', 'cp', 'rm', 'konqueror', 'du', 'ln'])
previously_activated_window = None
message_you_can_now_select_a_file = { True:_("")
                                      , False: _("") }
def point_to_string(p):
    if p is None:
        return None
    else:
        return p.x, p.y


def is_utility_window(w):
    inf = kdecore.KWin.windowInfo(w, kdecore.NET.WMWindowType)
    t =  inf.windowType(kdecore.NET.NormalMask
                        | kdecore.NET.UtilityMask
                        | kdecore.NET.DesktopMask
                        | kdecore.NET.DockMask
                        | kdecore.NET.ToolbarMask)
    return t == kdecore.NET.Utility

class WindowInfo:
    def __init__(self, wid, name):
        self.wid = wid
        self.name = name
    def stringForPopupMenu(self):
        return self.name



def rebuild_window_list_if_it_was_deleted():
    if the_window_list_has_been_deleted:
        print "re-creating window list"
        create_window_list()
        windowlist_window.show()
        # BEGIN this must be before move, otherwise the win could be resized
        windowlist_window.resize(QSize(windowlist_wt_read_from_db, windowlist_ht_read_from_db))
        # END
        windowlist_window.move(QPoint(windowlist_x_read_from_db, windowlist_y_read_from_db))

class my_dcop_obj(DCOPExObj):
    def __init__(self):
        DCOPExObj.__init__(self, "activator")
        self.addMethod ("void activate_window_list(int, int)", self.activate_window_list)
        self.addMethod ("void activate_core()", self.activate_core)
    def activate_core(self):
        kdecore.KWin.forceActiveWindow(mainWindow.winId())
    def activate_window_list(self, position_of_applet, dragging):
        global last_position_of_applet

        rebuild_window_list_if_it_was_deleted()


        if last_position_of_applet != position_of_applet:
            last_position_of_applet = position_of_applet
            redraw_windows(remember_scroll = False
                           , reverse = position_of_applet == 1)
        if kwin_module.activeWindow() == windowlist_window.winId():
            windowlist_window.hide()
            kdecore.KWin.forceActiveWindow(mainWindow.winId())
        else:
            windowlist_window.move(QPoint(windowlist_x, windowlist_y))
            windowlist_window.show()
            kdecore.KWin.forceActiveWindow(windowlist_window.winId())
            # BEGIN dehighlight the last highlighted item
            if listBox['window'].lastMousePos != None:
                listBox['window'].lastMousePos = None
                listBox['window'].make_changes_visible() 
            # END
            if dragging ==1:
                windowlist_help_label.setText(_(">> Drag active: hold your mouse on a window for 1 second <<"))
                windowlist_help_label.startFlashing(config.gFlashingTimeForHelpMessage
                                                    , resetOriginalColorsWhenFinished = True)
            else:
                windowlist_help_label.setText(windowlist_default_message)

my_dcop_inst = my_dcop_obj()



class MyListWindow(kdeui.KMainWindow):
    def moveEvent(self, ev):
        #print "moveEvent"
        global windowlist_x, windowlist_y
        windowlist_x = self.x()
        windowlist_y = self.y()

    def resizeEvent(self, ev):
        #print "resizeEvent"
        global windowlist_wt, windowlist_ht
        windowlist_wt = self.width()
        windowlist_ht = self.height()

    def closeEvent(self, ev):
        global the_window_list_has_been_deleted, windowlist_x_read_from_db, windowlist_y_read_from_db
        global windowlist_wt_read_from_db, windowlist_ht_read_from_db
        windowlist_ht_read_from_db = self.height()
        windowlist_wt_read_from_db = self.width()
        windowlist_y_read_from_db = self.y()
        windowlist_x_read_from_db = self.x()
        the_window_list_has_been_deleted = True
        ev.accept()



last_cached_file = None
last_cached_file_is_file = None
last_cached_file_is_dir = None
def cached_is_file(x):
    global last_cached_file, last_cached_file_is_file, last_cached_file_is_dir
    if last_cached_file != x:
        last_cached_file = x
        last_cached_file_is_file = os.path.isfile(x)
        last_cached_file_is_dir = os.path.isdir(x)
    return last_cached_file_is_file
def cached_is_file_or_dir(x):
    global last_cached_file, last_cached_file_is_file, last_cached_file_is_dir
    if last_cached_file != x:
        last_cached_file = x
        last_cached_file_is_file = os.path.isfile(x)
        last_cached_file_is_dir = os.path.isdir(x)
    return last_cached_file_is_file or last_cached_file_is_dir
def cached_is_dir(x):
    global last_cached_file, last_cached_file_is_file, last_cached_file_is_dir
    if last_cached_file != x:
        last_cached_file = x
        last_cached_file_is_file = os.path.isfile(x)
        last_cached_file_is_dir = os.path.isdir(x)
    return last_cached_file_is_dir
        

def clearFileFiltersAndUpdate():
    clearAux('file')
def clearWindowFiltersAndUpdate():
    clearAux('window')
def clearArgumentFiltersAndUpdate():
    clearAux('argument')
def clearProgramFiltersAndUpdate():
    clearAux('program')

def clearAux(k):
    filterQuickText[k].clear()
    if k!= 'window':
        redraw_programs(remember_scroll = False)
        redraw_files(centering = True)
        redraw_history()
    if not the_window_list_has_been_deleted:
        redraw_windows(remember_scroll = True
                       ,  reverse = last_position_of_applet == 1)
    

class argument_info:
    def __init__(self, name, usage_count, last_usage_time):
        self.name = name
        self.usage_count = usage_count
        self.last_usage_time = last_usage_time

def file_to_iconset(x, size):
    x2 = os.path.normpath(x)
    def kde_iconset(f, size):
        url = kdecore.KURL()
        url.setFileName(f)
        return QIconSet(kio.KMimeType.pixmapForURL(url
                                                   , 0
                                                   , kdecore.KIcon.Desktop
                                                   , size))
    if cached_is_dir(x2):
        if '/' == x2:
            ic = QIconSet(QPixmap(config.imgDir + "file-manager.png"))
        else:
            if os.path.ismount(x2):
                if is_substring_of('cd', x2) or is_substring_of('dvd', x2):
                    loader = kdecore.KIconLoader()
                    ic = loader.loadIconSet( "cdrom_unmount"
                                             , kdecore.KIcon.Small
                                             , size)
                else:
                    loader = kdecore.KIconLoader()
                    ic = loader.loadIconSet( "hdd_unmount"
                                             , kdecore.KIcon.Small
                                             , size)
            else:
                if os.path.normpath( os.path.expanduser('~/')) == x2:
                    loader = kdecore.KIconLoader()
                    ic = loader.loadIconSet( "folder_home"
                                             , kdecore.KIcon.Small
                                             , size)
                else:
                    if x2 in favorite_files:
                        loader = kdecore.KIconLoader()
                        ic = loader.loadIconSet( "folder_favorite"
                                                 , kdecore.KIcon.Small
                                                 , size)
                            
                    else:
                        ic= kde_iconset(x2, size)


    elif cached_is_file(x2):
        ic= kde_iconset(x2, size)
    else:
        ic = QIconSet() # this is here because x may not be a file at all
    return ic

def file_to_icon(x, size):
    x2 = os.path.normpath(x)
    def kde_icon(f, size):
        url = kdecore.KURL()
        url.setFileName(f)
        return kio.KMimeType.pixmapForURL(url, 0, kdecore.KIcon.Desktop, size)
    if cached_is_dir(x2):
        if '/' == x2:
            ic = QPixmap(config.imgDir + "file-manager.png")
        else:
            if os.path.ismount(x2):
                if is_substring_of('cd', x2) or is_substring_of('dvd', x2):
                    loader = kdecore.KIconLoader()
                    ic = loader.loadIcon( "cdrom_unmount"
                                          , kdecore.KIcon.Desktop
                                          , size)
                else:
                    loader = kdecore.KIconLoader()
                    ic = loader.loadIcon( "hdd_unmount"
                                          , kdecore.KIcon.Desktop
                                          , size)
            else:
                if os.path.normpath( os.path.expanduser('~/')) == x2:
                    loader = kdecore.KIconLoader()
                    ic = loader.loadIcon( "folder_home"
                                          , kdecore.KIcon.Desktop
                                          , size)
                else:
                    if x2 in favorite_files:
                        loader = kdecore.KIconLoader()
                        ic = loader.loadIcon( "folder_favorite"
                                              , kdecore.KIcon.Desktop
                                              , size)
                            
                    
                    else:
                        ic= kde_icon(x2, size)


    elif cached_is_file(x2):
        ic= kde_icon(x2, size)
    else:
        ic = QPixmap() # this is here because x may not be a file at all
    return ic

redraw_history_count = 0

def redraw_history(remember_scroll = False):

    # BEGIN debug
    global redraw_history_count
    print "redraw history " + str(redraw_history_count)
    redraw_history_count = redraw_history_count +1
    # END
    
    if remember_scroll:
        offs = listBox['argument'].scrollingOffset

    def name_to_be_searched_for_filter(full_path):
        if show_full_paths_in_history:
            return full_path
        else:
            return os.path.basename(full_path)
        
    
    def split_and_sort_args(pairs):
        k = 'argument'
        tx = sortBox[k].currentText()
        if tx == _("Name"):
            pairs.sort(lambda p1, p2: cmp(p1.name, p2.name))
            names = [x.name for x in pairs]
            return [(_('Sorted by name'), names)]
        elif tx == _('Recent usage'):
            pairs.sort(lambda p1, p2: -cmp(p1.last_usage_time, p2.last_usage_time))
            names = [x.name for x in pairs]
            return [  (_('Recently used'), names)]
        elif tx == _('Frequent usage'):
            pairs.sort(lambda p1, p2: -cmp(p1.usage_count, p2.usage_count))
            names = [x.name for x in pairs]
            return [  (_('Frequently used '), names)]
        else:
            raise "error"


    bulb_pix_mouseover = apply_pixmap
    bulb_pix_default = bulb_pix_mouseover
        
    k = 'argument'
    listBox[k].clear()
    filt = str(filterQuickText[k].text())
    if filt != "":
        filter_string =  _("Containing \"") + filt + "\"; "
    else:
        filter_string = ""

    if narrow_history_tabbar.currentTab() == id_of_tab_show_opt:
        not_a_file_string = "Is an option; "
    else:
        not_a_file_string = ""
    if narrow_history_tabbar.currentTab() == id_of_tab_show_fav:
        important_dir_string = "Is a favorite; "
    else:
        important_dir_string = ""
    if narrow_history_tabbar.currentTab() == id_of_tab_show_dirs:
        dir_string = "Is a folder; "
    else:
        dir_string = ""
    if narrow_history_tabbar.currentTab() == id_of_tab_show_files:
        file_string = "Is a file; "
    else:
        file_string = ""
    if program_focused_in_history != None:
        pairs = program_focused_in_history.arguments_used()

        pairs_filtered = [a for a in pairs
                          if  is_substring_of(filt,
                                              name_to_be_searched_for_filter(a.name))]
        if narrow_history_tabbar.currentTab() == id_of_tab_show_opt:
            pairs_filtered2 = [a for a in pairs_filtered
                               if a.name[0] != '/']
        else:
            pairs_filtered2 = pairs_filtered
        if narrow_history_tabbar.currentTab() == id_of_tab_show_fav:
            pairs_filtered3 = [a for a in pairs_filtered2
                               if a.name in favorite_files]
        else:
            pairs_filtered3 = pairs_filtered2
        if narrow_history_tabbar.currentTab() == id_of_tab_show_dirs:
            pairs_filtered4 = [a for a in pairs_filtered3
                               if os.path.isdir(a.name)]
        else:
            pairs_filtered4 = pairs_filtered3
        if narrow_history_tabbar.currentTab() == id_of_tab_show_files:
            pairs_filtered5 = [a for a in pairs_filtered4
                               if os.path.isfile(a.name)]
        else:
            pairs_filtered5 = pairs_filtered4

        l = split_and_sort_args(pairs_filtered5)
        trunc = 40 
        for j in range(0, len(l)):
            i = l[j]
            (sorting_string, args) = i
            # BEGIN append separator and label
            if j != 0:
                listBox[k].items.append(EmptySeparator( listBox[k].listArea.width()))
            listBox[k].items.append(
                TextSeparator(_('Used with ' + program_focused_in_history.short_name() + "; ")
                              + not_a_file_string
                              + important_dir_string
                              + dir_string
                              + file_string
                              + filter_string
                              + sorting_string
                              , listBox[k].listArea.width()
                              , data = "removable section of history panel"))
            # END
            for x in args[:trunc]:
                if x in selected_files:
                    press = "pressed"
                else:
                    press = "released"


                if cached_is_dir(x):
                    bic = [ text_item_button_info( [ QPixmap(config.imgDir +  "closed-door.png")
                                                     , QPixmap(config.imgDir + "open-door.png")]
                                                   , "enter folder"
                                                   , "not a togglebutton" )]
                else:
                    bic = []


                icon_size = 22
                if cached_is_file_or_dir(x):
                    icon =  [file_to_icon(x, icon_size)]
                else:
                    if x[0] == '/':
                        icon = [QPixmap(config.imgDir + "stock_toilet-paper.png")]
                    else:
                        icon = [QPixmap()]

                if os.path.islink(x):
                    icon.append( loader.loadIcon( "link", kdecore.KIcon.Desktop, icon_size))


                if show_full_paths_in_history:
                    visible_name = x
                else:
                    if x[0] == '/' and len(x) > 1:
                        visible_name = os.path.basename(x)
                    else:
                        visible_name = x

                if x in files_to_move or x in files_to_copy:
                    grey = "light grey"
                else:
                    grey = "black"

                listBox[k].items.append(TextItem(
                    text = visible_name,
                    icon = icon,
                    buttons_info = bic,
                    isSelectable =   True #main_program_in_command(str(commandEntry.text())) != None,
                    ,parent_list = listBox[k]
                    , pressed = x in selected_files
                    , data = x
                    , resolution_mult = resolution_multiplier
                    , grey_level = grey
                    ))
            if len(args) > trunc:
                listBox[k].items.append(TextItem(
                    text = _("(The list was too long and has been truncated. If you cannot find the item you need, you can narrow the list with the buttons above or with the filter box below.)"),
                    icon = [QPixmap()],
                    buttons_info = [],
                    isSelectable = False,
                    parent_list = listBox[k],
                    pressed = False,
                    data = ""
                    , resolution_mult = resolution_multiplier
                    , grey_level = "dark grey"))
            if args == []:
                listBox[k].items.append(TextItem(text = "(no argument exists that satisfies the above conditions)",
                                                 icon = [QPixmap()],
                                                 buttons_info = [],
                                                 isSelectable = False,
                                                 parent_list = listBox[k],
                                                 pressed = False,
                                                 data = ""
                                                 , resolution_mult = resolution_multiplier, grey_level = "dark grey"))
    if program_focused_in_history == None or  len(pairs_filtered5) < 20:
        pairs_filtered = [a for a in arguments_used_with_any_program
                          if  is_substring_of(filt,
                                              name_to_be_searched_for_filter(a.name))]

        if narrow_history_tabbar.currentTab() == id_of_tab_show_opt:
            pairs_filtered2 = [a for a in pairs_filtered
                               if a.name[0] != '/']
        else:
            pairs_filtered2 = pairs_filtered
        if narrow_history_tabbar.currentTab() == id_of_tab_show_fav:
            pairs_filtered3 = [a for a in pairs_filtered2
                               if a.name in favorite_files]
        else:
            pairs_filtered3 = pairs_filtered2
        if narrow_history_tabbar.currentTab() == id_of_tab_show_dirs:
            pairs_filtered4 = [a for a in pairs_filtered3
                               if os.path.isdir(a.name)]
        else:
            pairs_filtered4 = pairs_filtered3
        if narrow_history_tabbar.currentTab() == id_of_tab_show_files:
            pairs_filtered5 = [a for a in pairs_filtered4
                               if os.path.isfile(a.name)]
        else:
            pairs_filtered5 = pairs_filtered4

        l = split_and_sort_args(pairs_filtered5)

        if program_focused_in_history == None:
            trunc = 40
        else:
            trunc = 30
        for j in range(0, len(l)):
            i = l[j]
            (sorting_string, args) = i
            if j != 0:
                listBox[k].items.append(EmptySeparator( listBox[k].listArea.width()))
            listBox[k].items.append(
                    TextSeparator(_('Used in any way; ')
                                  + not_a_file_string
                                  + important_dir_string
                                  + dir_string
                                  + file_string
                                  + filter_string
                                  + sorting_string
                                  , listBox[k].listArea.width()
                                  , data = "not removable section"))
            for x in args[:trunc]:
                if x in selected_files:
                    press = "pressed"
                else:
                    press = "released"

                if cached_is_dir(x):
                    bic = [ text_item_button_info( [ QPixmap(config.imgDir +  "closed-door.png")
                                                     , QPixmap(config.imgDir + "open-door.png")]
                                                   , "enter folder"
                                                   , "not a togglebutton" )]
                else:
                    bic = []

                icon_size = 22
                if cached_is_file_or_dir(x):
                    icon =  [file_to_icon(x, icon_size)]
                else:
                    if x[0] == '/':
                        icon = [QPixmap(config.imgDir + "stock_toilet-paper.png")]
                    else:
                        icon = [QPixmap()]
                if os.path.islink(x):
                    icon.append( loader.loadIcon( "link", kdecore.KIcon.Desktop, icon_size))




                if show_full_paths_in_history:
                    visible_name = x
                else:
                    if x[0] == '/' and len(x) > 1:
                        visible_name = os.path.basename(x)
                    else:
                        visible_name = x

                if x in files_to_move or x in files_to_copy:
                    grey = "light grey"
                else:
                    grey = "black"
  
                listBox[k].items.append(TextItem(
                    text = visible_name ,
                    icon = icon,
                    buttons_info = bic,
                    isSelectable =  True 
                    , parent_list = listBox[k]
                    , pressed = x in selected_files 
                    , data = x
                    , resolution_mult = resolution_multiplier
                    , grey_level = grey
                    ))
            if len(args) > trunc:
                listBox[k].items.append(TextItem(
                    text = _("(The list was too long and has been truncated. If you cannot find the item you need, you can narrow the list with the buttons above or with the filter box below)"),
                    icon = [QPixmap()],
                    buttons_info = [],
                    isSelectable = False,
                    parent_list = listBox[k],
                    pressed = False,
                    data = ""
                    , resolution_mult = resolution_multiplier
                    , grey_level = "dark grey"))
            if args == []:
                listBox[k].items.append(TextItem(text = "(no argument exists that satisfies the above conditions)",
                                                 icon = [QPixmap()],
                                                 buttons_info = [],
                                                 isSelectable = False
                                                 , parent_list = listBox[k]
                                                 , pressed = False
                                                 , data = ""
                                                 , resolution_mult = resolution_multiplier, grey_level = "dark grey"))

    if remember_scroll and offs < len(listBox['argument'].items):
        listBox['argument'].scrollingOffset = offs
    listBox[k].make_changes_visible()

def onFilterKeyTimer(widget):
    applyFilter()
    
def onEnterPressedOnFilter():
    applyFilter()
    
def applyFilter():
    global recent_filters
    redraw_programs(remember_scroll = False)
    redraw_files()
    redraw_history()
    if not the_window_list_has_been_deleted:
        redraw_windows(remember_scroll = True,  reverse = last_position_of_applet == 1)
    # BEGIN rebuild recent_filters[k] for all k
    for k in ['program', 'file', 'argument']:
        t = str(filterQuickText[k].text())
        if t:
            if t in recent_filters[k]:
                recent_filters[k].remove(t)
            recent_filters[k] = [t] + recent_filters[k]
        recent_filters[k] = (recent_filters[k])[:config.gMaxItemsInRecentLocMenu] # truncate
    # END
    rebuildFilterMenus()

def rebuildFilterMenus():
    for k in ['program', 'file', 'argument']:
        filterMenu[k].clear()
        l = recent_filters[k]
        l.reverse()
        for f in l:
            filterMenu[k].addItem(f, QIconSet(), item_data = f)
        l.reverse()

def onRecentFilterClicked(menu, filter):
    print "onRecentFilterClicked"
    k = find(['argument', 'file', 'program'], lambda x: menu is filterMenu[x])
    filterQuickText[k].setText(filter)
    applyFilter()
         


def split_and_sort_polymorphic(sort_criterion, objects_to_sort):

    if  sort_criterion == _("Name"):
        objects_to_sort.sort(lambda o1, o2: cmp(o1.name().lower(), o2.name().lower()))
        return [(_('Sorted by name'), objects_to_sort)]
    elif sort_criterion == _('Recent usage'):
        usedObjs = [ x for x in objects_to_sort if x.last_usage_time() != None]
        unusedObjs = [x for x in objects_to_sort if x.last_usage_time() == None]
        unusedObjs.sort(lambda o1, o2: cmp(o1.name().lower(),   o2.name().lower()))
        usedObjs.sort(lambda o1, o2: -cmp( o1.last_usage_time() , o2.last_usage_time()))
        return [  (_('Recently used'), usedObjs) ,
                  (_('Never used'), unusedObjs)]
    elif sort_criterion == _("Frequent usage"):
        usedObjs = [x for x in objects_to_sort if x.usage_count() != 0]
        unusedObjs = [x for x in objects_to_sort if x.usage_count() == 0]
        unusedObjs.sort(lambda o1, o2: cmp(o1.name().lower(), o2.name().lower()))
        usedObjs.sort(lambda o1, o2: - cmp(o1.usage_count(), o2.usage_count()))
        return [
                (_('Frequently used'), usedObjs),
                (_('Never used'), unusedObjs)]
    else:
        raise "error: bla bla" 
    

# @@ TODO: remove this, in favour of split_and_sort_polymorphic
def split_and_sort_files_or_progs(k, last_usage_hash, usage_count_hash, objects_to_sort):

    tx = sortBox[k].currentText()
    if  tx == _("Name"):
        objects_to_sort.sort(lambda o1, o2: cmp(o1.lower(), o2.lower()))
        return [(_('Sorted by name'), objects_to_sort)]
    elif tx == _('Recent usage'):
        usedObjs = [ x for x in objects_to_sort if last_usage_hash.get(x, None) != None]
        unusedObjs = [x for x in objects_to_sort if last_usage_hash.get(x, None) == None]
        unusedObjs.sort(lambda o1, o2: cmp(o1.lower(),   o2.lower()))
        usedObjs.sort(lambda o1, o2: -cmp(last_usage_hash[o1],last_usage_hash[o2]))
        return [  (_('Recently used'), usedObjs) ,
                  (_('Never used'), unusedObjs)]
    elif tx == _("Frequent usage"):
        usedObjs = [x for x in objects_to_sort if usage_count_hash.get(x, 0) != 0]
        unusedObjs = [x for x in objects_to_sort if usage_count_hash.get(x, 0) == 0]
        unusedObjs.sort(lambda o1, o2: cmp(o1.lower(), o2.lower()))
        usedObjs.sort(lambda o1, o2: - cmp(usage_count_hash[o1], usage_count_hash[o2]))
        return [
                (_('Frequently used'), usedObjs),
                (_('Never used'), unusedObjs)]
    elif tx  == _("Date"):
        objects_to_sort.sort(lambda o1, o2: -cmp(os.path.getmtime(o1), os.path.getmtime(o2)))
        return [ (_('Most recently modified first'), objects_to_sort)]
    elif tx == _("Size"):
        withSize = [o for o in objects_to_sort if os.path.isfile(o)]
        withoutSize = [ o for o in objects_to_sort if not os.path.isfile(o)]
        withSize.sort(lambda o1, o2: -cmp(os.path.getsize(o1), os.path.getsize(o2)))
        withoutSize.sort(lambda o1, o2: cmp(o1.lower(), o2.lower()))
        return [ (_('Biggest first'), withSize),
                 (_('No size'), withoutSize)]
    else:
        raise "error: the current text is invalid: " + tx + " " + sortBox[k].currentText()




def onLocationButtonPressed(but):
    text_item_clicked( file_name = cur_dir,
                       clicked_from_history_panel = False)


        
def pid(w):
    prop = [ kdecore.NET.WMPid, 0]
    inf = kdecore.NETWinInfo(   w
                                , qt_xrootwin()
                                , prop
                                , 2)
    return inf.pid()

def is_desktop_or_dock_or_utility_window(w):
    inf = kdecore.KWin.windowInfo(w, kdecore.NET.WMWindowType)
    t =  inf.windowType(kdecore.NET.NormalMask
                        | kdecore.NET.UtilityMask
                        | kdecore.NET.DesktopMask
                        | kdecore.NET.DockMask
                        | kdecore.NET.ToolbarMask)
    return t == kdecore.NET.Desktop or t==kdecore.NET.Dock or t==kdecore.NET.Utility


def redraw_windows(remember_scroll, reverse ): 
    if remember_scroll:
        scroll = listBox['window'].scrollingOffset
    listBox['window'].clear()
    def get_window_name(wid):
        inf = kdecore.KWin.windowInfo(wid)
        return inf.visibleName()

    tx = sortBox['window'].currentText()
    if tx == _("Recent usage"):
        windows = windows_sorted_by_usage
        msg = _("     Most recently used")
    else:
        windows = windows_sorted_by_creation_date
        msg = _("     Most recently created")
    interesting_windows = [ x for x in windows
                            if x != windowlist_window.winId()
                            if not is_desktop_or_dock_or_utility_window(x)]
    if reverse:
        interesting_windows.reverse()
    else:
        listBox['window'].items.append(
            TextSeparator(msg
                          , listBox['window'].listArea.width()
                          , data = "not removable section"))
    loader = kdecore.KIconLoader()
    string_result = QString()
    on_top_button_default_pix = loader.loadIcon("edit_add", kdecore.KIcon.Small
                                                , 0
                                                , kdecore.KIcon.DefaultState
                                                , string_result
                                                , True)
    if on_top_button_default_pix.isNull():
        on_top_button_default_pix = loader.loadIcon("apply", kdecore.KIcon.Small)
        
    
    for w in interesting_windows:
        name = get_window_name(w)
        filt = str(filterQuickText['window'].text())
        if is_substring_of(filt, name) and w != windowlist_window.winId():
            listBox['window'].items.append(
                TextItem(text = name
                         , icon = [kdecore.KWin.icon(w, 26, 26, True)]
                         , buttons_info = [text_item_button_info( [ on_top_button_default_pix
                                                                    , on_top_button_default_pix]
                                                                  , "bring on top"
                                                                  , "not a togglebutton")]
                         , isSelectable = True
                         , parent_list =   listBox['window']
                         , pressed = False
                         , data = w
                         , resolution_mult = resolution_multiplier))
    if reverse:
        listBox['window'].items.append(
            TextSeparator(msg
                          , listBox['window'].listArea.width()
                          , data = "not removable section"))
    if remember_scroll:
        listBox['window'].scrollingOffset = scroll
        listBox['window'].make_changes_visible()
    else:
        if reverse:
            listBox['window'].onGotoBottomClicked()
        else:
            listBox['window'].make_changes_visible()



def rebuild_progs_that_can_manage_some_file():
    global cli_programs_that_can_manage_some_file__classes
    global mime_programs_that_can_manage_some_file__classes
    cli_programs_that_can_manage_some_file__classes = [ q for q in cli_programs_installed__classes
                                                        if ( q.can_manage_some_type()
                                                             or
                                                             q.works_with_any_file())]

    mime_programs_that_can_manage_some_file__classes = [ q for q in mime_programs_installed__classes
                                                         if (q.can_manage_some_type()
                                                             or
                                                             q.works_with_any_file())]

def found_mount_point(mount_point, kBSize, kBused, kBAvail):
    global free_space_in_cur_dir
    free_space_in_cur_dir = kio.KIO.convertSizeFromKB(kBAvail)
    update_info_bar()


    
def find_free_space_in_folder(folder_path):

    job = kfile.KDiskFreeSp.findUsageInfo(folder_path)

    QObject.connect( job,
                     SIGNAL( "foundMountPoint( const QString&,  unsigned long,  unsigned long, unsigned long )"),
                     found_mount_point)




def redraw_files(centering = False):
    # BUG: @@ cur_dir might stop being an existing directory anywhere
    # during the execution of this function. This is because the user
    # could be running a "rm -rf" command in background.


    # BEGIN @@ quick hack to fix the above bug in a *limited* way.
    global cur_dir
    if not os.path.isdir(cur_dir):
        cur_dir_watcher.removeDir(cur_dir)
        cur_dir = '/'
        cur_dir_watcher.addDir(cur_dir)
        os.chdir(cur_dir)
        find_free_space_in_folder(cur_dir)


    # END
    
    k = 'file'
    bulb_pix_mouseover = apply_pixmap
    bulb_pix_default = bulb_pix_mouseover

    if centering:
        offs = listBox['file'].scrollingOffset

    locationButton.setText(cur_dir)
    locationButton.data = cur_dir
    QToolTip.add(locationButton, cur_dir + _("\n\nThe content of this folder is shown below.\nThis is also the current working directory for shell commands."))
    the_loc_button_was_pressed = locationButton.pressed
    locationButton.pressed = cur_dir in selected_files
    if locationButton.pressed != the_loc_button_was_pressed:
        locationButton.make_changes_visible()

    dir_pix = QPixmap(file_to_icon(cur_dir, 16))
    current_dir_icon.setPixmap(dir_pix)
    listBox['file'].clear()
    cur_dir_slash = addSlashIfNeeded(cur_dir)
    files_without_path = [x for x in os.listdir(cur_dir)]
    files_with_path = [ cur_dir_slash + x for x in files_without_path]
    dirs = [o for o in files_with_path if os.path.isdir(o)]
    ordinary_files = [o for o in files_with_path if os.path.isfile(o)]
    executable_files = [o for o in ordinary_files if
                        os.access(o, os.X_OK)]
    filt = str(filterQuickText['file'].text())
    interesting_files = [x for x in dirs + ordinary_files if is_substring_of(filt, os.path.basename(x))]
    pairs = split_and_sort_files_or_progs(k = 'file'
                                      , last_usage_hash = last_usage_time_of_file
                                      , usage_count_hash = usage_count_of_file
                                      , objects_to_sort = interesting_files)

    def snd(x):
        (a, b) = x
        return b
    
    if forall(pairs, lambda pair: snd(pair) == []):
        
        if len(filt)>0:
            filter_msg = _("Containing \"") + filt + "\""
            listBox['file'].items.append( TextSeparator( filter_msg,
                                                         listBox[k].listArea.width()
                                                         , data = "not removable section"))
            msg =  _("No files were found that match the above criterion.")
        else:
            msg = _("This folder is empty.")
            
        
        listBox['file'].items.append(TextItem(
            text = msg,
            icon = [QPixmap()],
            buttons_info = [],
            isSelectable = False,
            parent_list = listBox['file'],
            pressed = False,
            data = ""
            , resolution_mult = resolution_multiplier, grey_level = "dark grey"))

    else: # there is at least one file to display in this folder
        previous_empty = True
        for i in pairs:
            (title, files) = i

            if len(filt) >0:
                title = _("Containing \"") + filt + "\"; " + title

            if files != []:
                if not previous_empty:
                    listBox[k].items.append(EmptySeparator( listBox[k].listArea.width()))
                previous_empty = False
                listBox['file'].items.append(TextSeparator(title, listBox[k].listArea.width()
                                                           , data = "not removable section"))
            else:
                previous_empty = True
            for x in files:
                #BEGIN make icons (ic =icon, bic = button icon)
                if x in selected_files:
                    press = "pressed"
                else:
                    press = "released"

                icon_size = 22
                ic = [file_to_icon(x, icon_size)]
                if os.path.islink(x):
                    ic.append( loader.loadIcon( "link", kdecore.KIcon.Desktop, icon_size))


                if x in dirs:
                    bic = [ text_item_button_info( [ QPixmap(config.imgDir +  "closed-door.png")
                                                     , QPixmap(config.imgDir + "open-door.png")]
                                                   , "enter folder"
                                                   , "not a togglebutton" )]
                else:
                    bic = []
                    
                # END
                if x in files_to_move or x in files_to_copy:
                    grey = "light grey"
                else:
                    grey = "black"
                listBox['file'].items.append(TextItem(
                    text = os.path.basename(x),
                    icon = ic,
                    buttons_info = bic,
                    isSelectable = True
                    , parent_list = listBox['file']
                    , pressed = x in selected_files 
                    , data = x
                    , resolution_mult = resolution_multiplier
                    , grey_level = grey))
    # BEGIN scroll the list to restore the previous scrolling position
    if centering and offs < len(listBox['file'].items):
        listBox['file'].scrollingOffset = offs
    #END
    listBox['file'].make_changes_visible()

def is_substring_of(s, st):
    return st.lower().find(s.lower()) != -1



def types_selected_for_prog_narrowing():
    
    def mimetype_of_file(f):
        url = kdecore.KURL()
        url.setFileName(f)

        file_item = kio.KFileItem(kio.KFileItem.Unknown
                                  , kio.KFileItem.Unknown
                                  , url)
        return str(file_item.mimetype())

    s = Set()
    for f in selected_files:
        if os.path.isdir(f):
            # this is a speedup. KDE is slow determining the mimetype
            # of a directory
            s.add("inode/directory")
        else:
            s.add(mimetype_of_file(f))
    return s







#   This function rebuilds the program panel, according to the current
#   OneFinger "mode".  OneFinger has two modes: cli-mode and
#   mime-mode. In cli-mode, you compose a command line. In mime-mode,
#   it works as any ordinary file manager.  In mime-mode, the program
#   panel contains verbs (like cut, copy, paste, delete) and
#   mime-programs.  In cli-mode, the program panel contains the
#   programs in your path.
def redraw_programs(remember_scroll):


    def set_to_string(s):
        l = []
        for x in s:
            l.append( x)
        st = "\""
        for x in range(0, len(l)):
            if l[x] == "":
                l[x] = "<no type>"
            st += l[x]
            if x<len(l)-1:
                st += ", "
        return st + "\""

    if remember_scroll:
        offs = listBox['program'].scrollingOffset
    loader = kdecore.KIconLoader()

    show_args_pix_mouseover = loader.loadIcon( "forward"
                                               , kdecore.KIcon.Small
                                               , 0
                                               , kdecore.KIcon.DefaultState)

    show_args_pix_normal = show_args_pix_mouseover

    k = 'program'
    listBox[k].clear()
    filt = str(filterQuickText[k].text())

    selected_types = types_selected_for_prog_narrowing()

    if filt != "" or selected_files == []:
        programs_that_I_consider = ( verbs_wrapped
                                    +
                                    mime_programs_installed__classes
                                    +
                                    [custom_mime_program(c) for c in custom_mime_programs]
                                    +
                                    cli_programs_installed__classes)
    else:
        # in case the filter is empty, and there is at least one
        # selected file, I take a necessary optimization: I only
        # consider those programs that can manage some file.
        programs_that_I_consider = ( verbs_wrapped
                                    +
                                    mime_programs_that_can_manage_some_file__classes
                                    +
                                    [custom_mime_program(c) for c in custom_mime_programs]
                                    +
                                    cli_programs_that_can_manage_some_file__classes)
        
    # BEGIN this check is very expensive, and is the reason for the
    # above optimization.
    progs_that_can_manage_selected_files = [x for x in programs_that_I_consider
                                            if is_substring_of(filt, x.name())
                                            if ( forall(selected_types,
                                                        lambda t: x.can_manage_type(t))
                                                 or x.works_with_any_file() ) ]
    # END
    if filt == "":
        progs_that_cannot_manage_selected_files = [] # optimization.
    else:
        progs_that_cannot_manage_selected_files = [x for x in programs_that_I_consider
                                                   if not isinstance(x, verb)
                                                   if is_substring_of(filt, x.name())
                                                   if not ( forall(selected_types,
                                                                   lambda t: x.can_manage_type(t))
                                                            or x.works_with_any_file() ) ]

    if ( len(progs_that_cannot_manage_selected_files) == 0
         and len(progs_that_can_manage_selected_files) == 0):
        # BEGIN write the failure message
        if filt != "":
            filter_string =  _("Containing \"") + filt + "\"; "
            txt = _("No programs were found that satisy the above conditions. Please verify the program you need is installed. If it has been recently installed, please refresh the program panel with the \"rescan programs\" button, above. If you still can't see the program you need, please either 1. create a custom command line, or 2. use shell mode. You can create a custom command line by selecting a file and selecting the action \"custom command line\". You can switch OneFinger to shell mode by clicking the first toolbar button.")
        else:
            filter_string = ""
            txt = _("No programs were found that satisy the above conditions.")

        if len(selected_types)>0:
            narrowing_string = ( _("Can manage ")
                                 + set_to_string(selected_types)
                                 + "; ")
        else:
            narrowing_string = ""

        listBox[k].items.append(TextSeparator(
            narrowing_string
            + filter_string 
            , listBox[k].listArea.width()
            , data = "not removable section"))
        listBox[k].items.append(TextItem(
                    text = txt,
                    icon = [QPixmap()],
                    buttons_info = [],
                    
                    isSelectable = False,
                    parent_list = listBox[k],
                    pressed = False,
                    data = ""
                    , resolution_mult = resolution_multiplier
                    , grey_level = "dark grey"))


        # END


    else: # there is some program compatible with the selected files.
        
        for current_list_of_progs in [progs_that_can_manage_selected_files
                                      , progs_that_cannot_manage_selected_files]:

            l = split_and_sort_polymorphic( sort_criterion = sortBox['program'].currentText()
                                            , objects_to_sort = current_list_of_progs)
            if current_list_of_progs == progs_that_cannot_manage_selected_files:
                manage_string = _("May or may not manage ")
            else:
                manage_string = _("Can manage ")

            trunc = 50
            previous_empty = True
            for i in l:
                (sorting_string, progs) = i

                # BEGIN write the label for this group of programs
                if len(progs)>0:
                    if filt != "":
                        filter_string =  _("Containing \"") + filt + "\"; "
                    else:
                        filter_string = ""
                    if len(selected_types)>0:
                        narrowing_string = ( manage_string
                                             + set_to_string(selected_types)
                                             + "; ")
                    else:
                        narrowing_string = ""
                    if not previous_empty:
                        listBox[k].items.append(EmptySeparator( listBox[k].listArea.width()))
                    previous_empty = False
                    listBox[k].items.append(TextSeparator(narrowing_string
                                                          + filter_string 
                                                          + sorting_string
                                                          , listBox[k].listArea.width()
                                                          , data = "not removable section"))
                else:
                    previous_empty = True
                # END

                toilet_pixmap = QPixmap(config.imgDir + "stock_toilet-paper.png")
                for p in progs[:trunc]:
                    button_infos = []



                    if program_focused_in_history and p.name() == program_focused_in_history.name():
                        pressed = 'pressed'
                    else:
                        pressed = 'released'


                    if g_show_menu_buttons:
                        binf = [ text_item_button_info( [ QPixmap(config.imgDir +  "pale-red-ball.png")
                                                          , QPixmap(config.imgDir + "red-ball.png")]
                                                        , "show verb menu"
                                                        , "not a togglebutton" )]
                    else:
                        binf = []


                    listBox[k].items.append(TextItem(
                        text = p.name(),
                        icon = [p.icon()],
                        buttons_info = binf,
                        isSelectable = True,
                        parent_list = listBox[k]
                        , pressed = p in selected_actions # @@ custom_mime_programs are not highlighted
                        , data = p
                        , resolution_mult = resolution_multiplier
                        , grey_level = "black" ))

        if filt == "":
            if selected_files == []:
                txt = _("The list was too long and has been truncated. ")
            else:
                txt = _("OneFinger has hidden those programs that are not known to manage the selected files. ")
            # BEGIN write message "list truncated"
            listBox[k].items.append(TextItem(
                text = _("\n") + txt +

_("If you cannot see a program that you need, type its name (or part of it) in the search box below.  Then you will be able to use the program. Next time, the program will appear in this list, so you don't need to type its name again."),
                icon = [QPixmap()],
                buttons_info = [],
                isSelectable = False,
                parent_list = listBox[k],
                pressed = False,
                data = ""
                , resolution_mult = resolution_multiplier
                , grey_level = "dark grey"))
            # END
        else:
            # BEGIN write message "list truncated"
            listBox[k].items.append(TextItem(
                    text = _("\nIf you still cannot see the program you need, and you know it is installed, please either 1. create a custom command line, or 2. use shell mode. You can create a custom command line by selecting a file and selecting the action \"custom command line\". You can switch OneFinger to shell mode by clicking the first toolbar button.)"),
                    icon = [QPixmap()],
                    buttons_info = [],
                    isSelectable = False,
                    parent_list = listBox[k],
                    pressed = False,
                    data = ""
                    , resolution_mult = resolution_multiplier
                    , grey_level = "dark grey"))
            # END




    if remember_scroll and offs < len(listBox['program'].items):
        listBox['program'].scrollingOffset = offs
    listBox[k].make_changes_visible()



# BEGIN Qt only
#applic = QApplication(sys.argv)
# END

# BEGIN KDE only
# this must be before the creation of MyMainWindow
kdecore.KCmdLineArgs.init(sys.argv, "OneFinger", "Desktop environment", config.version)
applic = kdecore.KUniqueApplication(True, True, True)
# END


# BEGIN detect resolution
real_resolution =  kdecore.KApplication.desktop().width()

resolution_multiplier = float(real_resolution/1024.0)

# END


# BEGIN setup verbs
loader = kdecore.KIconLoader()
icon_of_verb = {'Drag to window':  QPixmap(config.imgDir + "stock_drag-mode.png")
                , 'Add to favorites' : QPixmap(config.imgDir + "gnome-favorites.png")
                , 'Remove from favorites' : QPixmap(config.imgDir + "remove-from-favorites.png")
                , 'Cut files': loader.loadIcon( "editcut", kdecore.KIcon.Desktop, 16)
                , 'Execute program': loader.loadIcon( "clanbomber", kdecore.KIcon.Desktop, 16)
                , 'Search folder': loader.loadIcon( "kfind", kdecore.KIcon.Desktop, 16)
                , 'Open with custom command line': QPixmap(config.imgDir + "hidden2.png")
                , 'Move files to trash' : loader.loadIcon( "edittrash", kdecore.KIcon.Desktop, 16)
                , 'Delete files': loader.loadIcon( "editdelete", kdecore.KIcon.Desktop, 16)
                , 'Open terminal here': loader.loadIcon( "konsole", kdecore.KIcon.Desktop, 16)
                , 'Create new folder here': loader.loadIcon( "folder_new", kdecore.KIcon.Desktop, 16)
                , 'Copy files': loader.loadIcon( "editcopy", kdecore.KIcon.Desktop, 16)
                , 'Paste files here': loader.loadIcon( "editpaste", kdecore.KIcon.Desktop, 16)
                , 'Paste link here': loader.loadIcon( "redo", kdecore.KIcon.Desktop, 16)
                , 'Properties': loader.loadIcon( "edit", kdecore.KIcon.Desktop, 16)
                }
verbs_unwrapped = [ 'Drag to window'
                    , 'Add to favorites'
                    , 'Search folder'
                    , 'Create new folder here'
                    , 'Remove from favorites'
                    , 'Cut files'
                    , 'Execute program'
                    , 'Open terminal here'
                    , 'Paste link here'
                    , 'Open with custom command line'
                    , 'Move files to trash'
                    , 'Delete files'
                    , 'Copy files'
                    , 'Paste files here'
                    , 'Properties']
verbs_wrapped = [verb(v) for v in verbs_unwrapped]

# def all_files_are_already_in_favorites(selection):
#     return forall(selection, lambda f : f in favorite_files)
# def no_file_is_favorite(selection):
#     return forall(selection, lambda f : not f in favorite_files)
# def no_file_is_selected(sel):
#     return len(sel) == 0
# def not_exactly_one_file_is_selected(sel):
#     return len(sel) != 1
# def not_exactly_one_dir_is_selected(sel):
#     return not( len(sel) == 1 and os.path.isdir(sel[0]))
# def no_file_is_selected_or_there_is_a_non_exec_file(sel):
#     return ( len(sel) == 0
#              or
#              exists(sel, lambda f: not os.access(f, os.X_OK))
#              or
#              exists(sel, lambda f: os.path.isdir(f)))
# def not_exactly_one_dir_is_selected_or_clipboard_empty(sel):
#     return ( not ( len(sel) == 1 and os.path.isdir(sel[0]))
#              or
#              ( files_to_move == [] and files_to_copy == []))


# greyed_condition_of_verb = { 'Add to favorites' : all_files_are_already_in_favorites
#                              , 'Remove from favorites' : no_file_is_favorite
#                              , 'Execute program' : no_file_is_selected_or_there_is_a_non_exec_file
#                              , 'Copy files' : no_file_is_selected
#                              , 'Search directory' : not_exactly_one_dir_is_selected
#                              , 'Paste link here' : not_exactly_one_dir_is_selected
#                              , 'Create new directory here' : not_exactly_one_dir_is_selected
#                              , 'Drag to window' : no_file_is_selected
#                              , 'Delete files' : no_file_is_selected
#                              , 'Open terminal here' : not_exactly_one_dir_is_selected
#                              , 'Properties' : no_file_is_selected
#                              , 'Move files to trash' : no_file_is_selected
#                              , 'Open with custom command line' : no_file_is_selected
#                              , 'Cut files' : no_file_is_selected
#                              , 'Paste files here' : not_exactly_one_dir_is_selected_or_clipboard_empty
#                              }
types_usable_with_verb = {  'Paste files here' : Set(['inode/directory'])
                            , 'Create new folder here' : Set(['inode/directory'])
                            , 'Open terminal here' : Set(['inode/directory'])
                            , 'Paste link here' : Set(['inode/directory'])
                            , 'Search folder' : Set(['inode/directory'])
                            , 'Execute program' : Set(['application/'])}
verbs_that_work_with_any_file = Set(['Drag to window'
                                     , 'Cut files'
                                     , 'Open with custom command line'
                                     , 'Copy files'
                                     , 'Delete files'
                                     , 'Move files to trash'
                                     , 'Properties'
                                     , 'Add to favorites'
                                     , 'Remove from favorites'])


# END


createDirIfNotExisting(config.dataDir)

def rescan_programs(display_wait_message = False):
    print _("Scanning programs, their supported mimetypes and their icons (takes a minute)...")

    global help_bar_visible
    global cli_programs_installed__classes
    #global mime_programs_that_can_manage_some_file__classes
    #global cli_programs_that_can_manage_some_file__classes
    
    # BEGIN display please-wait msg
    if display_wait_message:
        help_label.setText( _("Rescanning programs, their icons and supported mimetypes..."))
        help_label.stopFlashing(resetColor = True)
        if not help_bar_visible:
            help_bar_visible = True
            hide_help_button.hide()
            help_hbox.show()


        applic.processEvents() # have qt display the changes
    # END

    def read_mimetypes_and_rebuild_types_usable_with_them():

        global icon_of_cli_program, types_usable_with_cli_program
        global icon_of_mime_program, types_usable_with_mime_program
        global mime_programs_installed__classes
        global readable_name_of_mime_program, generic_name_of_mime_program
        global comment_of_mime_program, desktop_file_of_mime_program

        loader = kdecore.KIconLoader()

        # BEGIN create defaults
        icon_of_cli_program = {}
        icon_of_mime_program = {}
        comment_of_mime_program = {}
        types_usable_with_cli_program = { 'kuickshow': Set(['inode/directory'])
                              , 'konqueror': Set(['inode/directory'])
                              , 'kfind': Set(['inode/directory'])
                              , 'konsole': Set(['inode/directory'])
                              , 'kdirstat': Set(['inode/directory'])
                              , 'filelight': Set(['inode/directory'])
                              
                              }
        types_usable_with_mime_program = {}
        mime_programs_installed = []
        readable_name_of_mime_program = {}
        generic_name_of_mime_program = {}
        desktop_file_of_mime_program = {}
        # END
        
        
        services = kio.KService.allServices()
        programs_to_act_on = [x for x in services
                              if x.type_() == "Application"
                              if len(str(x.exec_())) > 0]

        # BEGIN deal with mime programs
        next_free_integer = {}
        for p in programs_to_act_on:
            # instantiate vars such as %c, %i, %m
#             def compute_exec_string_with_instantiated_vars(p):
#                 current_exec = str(p.exec_())
#                 current_exec = string.replace(current_exec, "%c"
#                                               , unicode(p.name())) # str(p.comment())) suse bug @@
#                 current_exec = string.replace(current_exec, "%i", " -icon ") # suse bug str(p.icon())) @@
#                 current_exec = string.replace(current_exec, "%m", str(p.icon()))
#                 return current_exec
                
            exec_string = str(p.exec_()) #compute_exec_string_with_instantiated_vars(p)
            if not exec_string in mime_programs_installed:
                mime_programs_installed.append(exec_string)
                types_usable_with_mime_program[exec_string] = [ str(mt) for mt in p.serviceTypes()]
                icon_of_mime_program[exec_string] = loader.loadIcon( p.icon()
                                                              , kdecore.KIcon.Small
                                                              , 22)
                try:
                    generic_name_of_mime_program[exec_string] = unicode(p.genericName())
                except UnicodeEncodeError:
                    generic_name_of_mime_program[exec_string] = str(p.genericName())
                try:
                    comment_of_mime_program[exec_string] = unicode(p.comment())
                except UnicodeEncodeError:
                    comment_of_mime_program[exec_string] = str(p.comment())
                # BEGIN decide the readable name, resolving collisions
                try:
                    preferred_readable_name = unicode(p.name())
                except UnicodeEncodeError:
                    preferred_readable_name = str(p.name())

                if exists(mime_programs_installed
                          , lambda x:(x != exec_string
                                      and
                                      readable_name_of_mime_program[x] == preferred_readable_name
                                      and
                                      comment_of_mime_program[x] == comment_of_mime_program[exec_string]
                                      and
                                      generic_name_of_mime_program[x] == generic_name_of_mime_program[exec_string] )):
                    # name collision detected: we have to append an
                    # integer to the preferred_readable_name
                    integ = next_free_integer.get(preferred_readable_name, 2)
                    final_readable_name = ( preferred_readable_name
                                            + " <" + unicode(integ) + ">")
                    next_free_integer[preferred_readable_name] = integ + 1
                else:
                    final_readable_name = preferred_readable_name

                readable_name_of_mime_program[exec_string] = final_readable_name
                # END

                try:
                    desktop_file_of_mime_program[exec_string] = unicode(p.desktopEntryPath())
                except UnicodeEncodeError:
                    desktop_file_of_mime_program[exec_string] = str(p.desktopEntryPath())
        # END

        mime_programs_installed__classes = [ mime_program(qq) for qq in mime_programs_installed]


        # BEGIN deal with cli programs. This is tricky because
        # freedesktop only specifies icons and mimetypes for
        # MIMEPROGRAMS. Not for cli programs. So we have to guess the
        # icon and mimetype for each cli program.

        def extract_program_names(cmd):
            return [os.path.basename(x) for x in string.split(str(cmd))]
        
        # first round: associate icon to most likely names, and also
        # associate types
        for p in programs_to_act_on:
            # BEGIN debug

#             print "\nname = " + str(p.name())
#             print "generic name = " + unicode(p.genericName()) # crashes without unicode
#             print "exec = " + str(p.exec_())
#             print "comment = " + str(p.comment())
#             print "path = " + str(p.path())
            
            #print "prog-names = "+ str(extract_program_names(p.exec_()))
            #print "icon = " + str(p.icon())
            #print "path = " + str(p.path())
            # END
            
            possible_prog_names = extract_program_names(p.exec_())

            most_likely_name = possible_prog_names[0]
            # BEGIN associate types 
            if types_usable_with_cli_program.get(most_likely_name, None) == None:
                types_usable_with_cli_program[most_likely_name] = Set()
            for s in p.serviceTypes():
                types_usable_with_cli_program[most_likely_name].add(str(s))
            # END

            # BEGIN scan icons of this program
            s = QString()
            pixm = loader.loadIcon( p.icon()
                                    , kdecore.KIcon.Small
                                    , 22
                                    , kdecore.KIcon.DefaultState
                                    , s
                                    , True )
            if (  pixm and not pixm.isNull()
                  and icon_of_cli_program.get(most_likely_name, None) == None ):
                icon_of_cli_program[most_likely_name] = pixm
            # END

        # second round: for those programs that don't have an icon
        # yet, associate least likely names
        for p in programs_to_act_on:
            possible_prog_names = extract_program_names(p.exec_())

            # BEGIN associate icons to the other programs in the list,
            # but only if they don't already have one
            for n in possible_prog_names[1:]:
                if icon_of_cli_program.get(n, None) == None :
                    # BEGIN scan icons of this program
                    loader = kdecore.KIconLoader()
                    s = QString()
                    pixm = loader.loadIcon( p.icon()
                                            , kdecore.KIcon.Small
                                            , 22
                                            , kdecore.KIcon.DefaultState
                                            , s
                                            , True )
                    if pixm and not pixm.isNull():
                        icon_of_cli_program[n] = pixm
                    # END
            # END

        # END (deal with cli programs)

    # BEGIN build cli_programs_in_path
    cli_programs_in_path = Set()
    pathlist = os.environ['PATH'].split(os.pathsep)
    for path in pathlist:
        # find prgs really there and allowed to execute
        if os.path.isdir(path): # covers the case where the user has an unexisting path in $PATH
            for p in os.listdir(path):
                full_path = os.path.join(path, p)
                if not os.path.isdir(full_path) and os.access(full_path, os.X_OK):
                    cli_programs_in_path.add(p)
    # END


    read_mimetypes_and_rebuild_types_usable_with_them()


    cli_programs_installed__classes = [cli_program(x) for x in cli_programs_in_path]


    rebuild_progs_that_can_manage_some_file()

    # BEGIN display "done" msg
    if display_wait_message:
        help_label.setText( _("New programs are now available."))
        help_label.startFlashing(config.gFlashingTimeForHelpMessage
                                 , resetOriginalColorsWhenFinished = True)
        hide_help_button.show()
    # END

    print _("...done")




# BEGIN build default arguments for programs
default_arguments = [ ("mplayer", [ "-vo", "sdl", "xv", "--enqueue", "-sub"])
                      ,("gmplayer", [ "-vo", "sdl", "xv", "--enqueue", "-sub"])
                      ,("totem", [ "--enqueue"])
                      ,("konsole", [ "--workdir"])
                      ,("xmms", [ "--enqueue"])
                      ,("k3b", [ "--emovixdvd", "--copycd", "--clonecd", "--erasecd", "--isoimage", "--binimage",
                                 "--formatdvd", "--datacd", "--audiocd", "--videocd", "--mixedcd", "--datadvd" ])
                      ,("xine", [ "--enqueue"])
                      ,("ark", [ "--extract", "--extract-to", "--add", "--add-to", "--guess-name"])
                      ,("file-roller", [ "--extract", "--extract-to=", "--add", "--add-to="])
                      ,("cp", [ "-r"])
                      ,("scp", [ "-r"])
                      ,("apt-cache", [ "show", "search"])
                      ,("dpkg", [ "-c","-i", "--install",  "--contents"])
                      ,("rpm", [ "-Uvh","-i", "-qpl", "--install"])
                      ,("tar", [ "-xzvf","-czvf", "-xjvf", "-cjvf"])
                      ,("mv", [ "-r"])
                      ,("du", [ "-s", "-h", "-sh", "--human-readable", "--summarize"])
                      ,("rm", [ "-r", "-f", "-rf"])
                      ,("btdownloadcurses", [ "--url"])
                      ,("chmod", [ "-R", "root:root", "*"])
                      ,("chown", [ "-R", "root:root", "*"])
                      ,("find", [ "-iname", "-exec", "{}", "-type d", "-type f" ])
                      ,("btdownloadgui", [ "--url"])
                      ,("df", [ "--human-readable"])
                      ,("ls", [ "--color", "-a", "-l", "-la"])
                      ,("emacs", [ "-nw"])
                      ,("echo", [ "$PATH"])
                      ,("apt", [ "search", "install", "--no-checksig"])
                      ,("apt-get", [ "update", "upgrade", "clean", "autoclean", "install"])
                      ,("update-alternatives", [ "--config", "x-window-manager", "x-terminal-emulator"
                                                 ,"x-www-browser", "x-session-manager", "editor"
                                                 , "emacs", "c++", "cc", "cli", "ctags", "editor", "dia"])
                      ]

default_arguments2 = {}
for pair in default_arguments:
    (prog_name, arg_list) = pair
    l2 = [argument_info(x, 1, time.gmtime()) for x in arg_list]
    default_arguments2[prog_name] = l2

# END

cached_command = None
cached_tokens = []
def do_shell_expans_then_tokenize(cmd):
    global cached_command
    global cached_tokens
    if cmp(cmd, cached_command)==0:
        #print "cache hit"
        return cached_tokens
    else:
        #print "cache miss"
        cached_command = cmd
        #print "invoking parser on " + cmd
        file =   os.popen(u'python ' + config.parser_file_dir + u'/parser.py ' + cmd, 'r')
        lines = file.readlines()
        file.close()
        cached_tokens = [string.strip(x) for x in lines[1:]]
        #print "result of parsing: "
        #print cached_tokens
        return cached_tokens


# def tokenize_method_2(cmd):
#     def is_even(x):
#         return x % 2 ==0
#     l = string.split(cmd, "\'")
#     if is_even(len(l)):
#         return "parse error - single quotes do not match"
#     else:
#         # now I know that the strings in even positions were
#         # single-quoted. I only have to split the other ones.
#         strings_still_to_parse = [ l[x] for x in range(len(l))
#                                    if not is_even(x) ]
        
#         for s in strings_still_to_parse:
#             l2 = parse_phase_2(s)
            
            
            
    
#



def update_db_for_file_on_top_of_recent_kde_files():
    global arguments_used_with_any_program
    # A .desktop file has been created in the dir that contains
    # .desktop files. It is the first .desktop files in the list of
    # recent ones returned by KDE. We must update the OneFinger
    # database with this file.
    print "update_db_for_file_on_top_of_recent_kde_files"

    # 1. find the desktop file that was created
    new_desktop_files = kfile.KRecentDocument.recentDocuments()
    new_desktop_file = new_desktop_files[0]

    # 2. find the corresponding file
    kdf = kdecore.KDesktopFile(new_desktop_file, True)
    real_file = os.path.normpath(str( kdecore.KURL(kdf.readURL()).path()))

    # 3. find the usage time of the file
    usage_time_of_real_file = time.gmtime(os.path.getmtime(str(new_desktop_file)))

    # 4. update the db
    x = find(arguments_used_with_any_program
             , lambda a: os.path.normpath(a.name) == real_file)
    # if the file is already in the database...
    if x != None:
        print "already in the database: " + real_file
        # if the file has been used outside OneFinger since last
        # time...
        assert x.last_usage_time <= usage_time_of_real_file
        if x.last_usage_time < usage_time_of_real_file:
            # ...increase its usage count and update its last
            # usage time.
            arguments_used_with_any_program.remove(x)
            arguments_used_with_any_program.append(
                argument_info( real_file
                               , x.usage_count +1
                               , usage_time_of_real_file))
    else:
        print "not in the database" + real_file
        # insert the file in the db, with usage_count = 1 and last
        # usage time.
        arguments_used_with_any_program.append(
            argument_info( real_file
                           , 1
                           , usage_time_of_real_file))



def on_dir_with_desktop_files_dirty(dir):
    print "on_dir_with_desktop_files_dirty"
    update_db_for_file_on_top_of_recent_kde_files()
    redraw_history()
watcher_of_dir_with_desktop_files = kio.KDirWatch()
watcher_of_dir_with_desktop_files.addDir(
     kfile.KRecentDocument.recentDocumentDirectory())
QObject.connect(watcher_of_dir_with_desktop_files
                , SIGNAL("dirty(const QString&)")
                , on_dir_with_desktop_files_dirty)


#


cur_dir_watcher = kio.KDirWatch()
def on_cur_dir_dirty(d):
    redraw_files(centering = True) # @@ I changed it from False. Risk?
    redraw_history()
QObject.connect(cur_dir_watcher, SIGNAL("dirty(const QString&)"), on_cur_dir_dirty)



home = os.path.normpath( os.path.expanduser('~/'))
# BEGIN read database
def parse_arguments_used_with_any_program_from_bash_profile():
#     file = os.open('~/.bash_profile', 'r')
#     lines = file.readlines()
#     file.close()
#     print lines
    return [argument_info('/', 1, time.gmtime())
            , argument_info(home, 1, time.gmtime())]


newbie_labels_visible = persistence.loadVariableFromFile(config.dataDir + 'newbie_labels_visible'
                                                         , default = True)

g_show_menu_buttons = persistence.loadVariableFromFile(config.dataDir + 'g_show_menu_buttons'
                                                       , default = False)

show_full_paths_in_history = persistence.loadVariableFromFile(config.dataDir + 'show_full_paths_in_history'
                                                              , default = True)
windowlist_x_read_from_db = persistence.loadVariableFromFile(config.dataDir + 'windowlist_x'
                                                   , default = None)
windowlist_y_read_from_db = persistence.loadVariableFromFile(config.dataDir + 'windowlist_y'
                                                   , default = None)
windowlist_wt_read_from_db = persistence.loadVariableFromFile(config.dataDir + 'windowlist_wt'
                                                   , default = None)
windowlist_ht_read_from_db = persistence.loadVariableFromFile(config.dataDir + 'windowlist_ht'
                                                   , default = None)
help_bar_visible =persistence.loadVariableFromFile(config.dataDir + 'help_bar_visible'
                                                   , default = True)
arguments_used_with_any_program =persistence.loadVariableFromFile(
    config.dataDir + 'arguments_used_with_any_program'
    , default = parse_arguments_used_with_any_program_from_bash_profile())
types_used_with_cli_program = persistence.loadVariableFromFile(
    config.dataDir + 'types_used_with_cli_program'
    , default = {})
types_used_with_mime_program = persistence.loadVariableFromFile(
    config.dataDir + 'types_used_with_mime_program'
    , default = {})
types_used_with_custom_mime_program = persistence.loadVariableFromFile(
    config.dataDir + 'types_used_with_custom_mime_program'
    , default = {})

types_usable_with_custom_mime_program = persistence.loadVariableFromFile(
    config.dataDir + 'types_usable_with_custom_mime_program'
    , default = {})


program_runs_in_terminal = persistence.loadVariableFromFile(config.dataDir + 'program_runs_in_terminal', default = {})
cur_dir = persistence.loadVariableFromFile(config.dataDir + 'cur_dir', default = '/')
if os.path.isdir(cur_dir):
    cur_dir_watcher.addDir(cur_dir)
    os.chdir(cur_dir)
    find_free_space_in_folder(cur_dir)
    # redraw_files() will change cur_dir if it does not exist


custom_mime_programs = persistence.loadVariableFromFile(
    config.dataDir + 'custom_mime_programs',
    default = [])
readable_name_of_custom_mime_program = persistence.loadVariableFromFile(
    config.dataDir + 'readable_name_of_custom_mime_program',
    default = {})


arguments_of_cli_program = persistence.loadVariableFromFile(
    config.dataDir + 'arguments_of_cli_program',
    default = default_arguments2)
arguments_of_mime_program = persistence.loadVariableFromFile(
    config.dataDir + 'arguments_of_mime_program',
    default = {})
arguments_of_verb = persistence.loadVariableFromFile(
    config.dataDir + 'arguments_of_verb',
    default = {})
arguments_of_custom_mime_program = persistence.loadVariableFromFile(
    config.dataDir + 'arguments_of_custom_mime_program',
    default = {})

favorite_files = persistence.loadVariableFromFile(config.dataDir
                                                         + 'favorite_files'
                                                         , default = ['/', home])
last_usage_time_of_file = persistence.loadVariableFromFile(
    config.dataDir
    + 'last_usage_time_of_file'
    , default = { '/' : time.gmtime()
                  , home : time.gmtime() } )
last_usage_time_of_cli_program = persistence.loadVariableFromFile(
    config.dataDir + 'last_usage_time_of_cli_program', default = {})
last_usage_time_of_verb = persistence.loadVariableFromFile(
    config.dataDir + 'last_usage_time_of_verb', default = {})
last_usage_time_of_mime_program = persistence.loadVariableFromFile(
    config.dataDir + 'last_usage_time_of_mime_program', default = {})
last_usage_time_of_custom_mime_program = persistence.loadVariableFromFile(
    config.dataDir + 'last_usage_time_of_custom_mime_program', default = {})
recent_filters = persistence.loadVariableFromFile(config.dataDir + 'recent_filters',
                                                  default = {'file': [], 'argument':[], 'program':[], 'window':[]})
sorting_criterion_for_dir = persistence.loadVariableFromFile(
    config.dataDir + 'sorting_criterion_for_dir', default = {})
sorting_criterion_for_arguments = persistence.loadVariableFromFile(
    config.dataDir + 'sorting_criterion_for_arguments'
    , default = "Recent usage")
sorting_criterion_for_programs = persistence.loadVariableFromFile(
    config.dataDir + 'sorting_criterion_for_programs'
    , default = "Recent usage")

usage_count_of_file = persistence.loadVariableFromFile(config.dataDir
                                                       + 'usage_count_of_file'
                                                       , default = {'/': 1, home:1})
usage_count_of_cli_program = persistence.loadVariableFromFile(
    config.dataDir + 'usage_count_of_cli_program', default = {})
usage_count_of_verb = persistence.loadVariableFromFile(
    config.dataDir + 'usage_count_of_verb', default = {})
usage_count_of_mime_program = persistence.loadVariableFromFile(
    config.dataDir + 'usage_count_of_mime_program', default = {})
usage_count_of_custom_mime_program = persistence.loadVariableFromFile(
    config.dataDir + 'usage_count_of_custom_mime_program', default = {})
# END




mainWindow = kdeui.KMainWindow()
mainWindow.setIcon(QPixmap(config.imgDir + "onefinger.png")) # ignored for a kde bug, but affects child windows

applic.setMainWidget(mainWindow)

spacing = int (3.0 * resolution_multiplier)


popup_menu_of_action_panel = MyPopupMenu(mainWindow)


def on_item_chosen_from_popup_menu_of_action_panel(menu, item_data):
    global selected_actions
    global program_focused_in_history
    global cur_dir
    
    (action_meaning, action_arg) = item_data
        
    if action_meaning == "Delete":
        del usage_count_of_custom_mime_program[action_arg.exec_]
        del last_usage_time_of_custom_mime_program[action_arg.exec_]
        del readable_name_of_custom_mime_program[action_arg.exec_]
        del arguments_of_custom_mime_program[action_arg.exec_]
        del types_used_with_custom_mime_program[action_arg.exec_]
        del types_usable_with_custom_mime_program[action_arg.exec_]
        
        custom_mime_programs.remove(action_arg.exec_)

        redraw_programs(remember_scroll = True)
        listBox['program'].flash_all_items(config.gFlashingTimeForList)
    elif action_meaning == "Show files used with":
            
        program_focused_in_history = action_arg

        files_tab_widget.showPage(vbox['argument'])

        if narrow_history_tabbar.currentTab() != id_of_tab_show_all:
            narrow_history_tabbar.setCurrentTab(show_everything_in_hist_panel)       # calls redraw_history()
        else:
            redraw_history()
            
        listBox['argument'].flash_all_items(config.gFlashingTimeForList)


    elif action_meaning == "Hide category":
        QMessageBox.information(mainVBox, _("Not removable."), _("This category cannot be hidden."))
    elif action_meaning == "Forget this has been used":
        action_arg.forget_this_has_been_used()
        redraw_programs(remember_scroll = True) 
        listBox['program'].flash_all_items(config.gFlashingTimeForList)
    else:
        QMessageBox.information(mainVBox, _("Not implemented."),
                                _("This feature has not yet been implemented."))
        

QObject.connect(popup_menu_of_action_panel,
                PYSIGNAL("itemActivated"),
                on_item_chosen_from_popup_menu_of_action_panel)


popup_menu_of_history_panel = MyPopupMenu(mainWindow)
popup_menu_of_file_panel = MyPopupMenu(mainWindow)


def on_list_item_button_pressed(list, item, button_meaning):

    global cur_dir


    if button_meaning == "show verb menu":
        
        popup_menu_of_action_panel.clear()

        # BEGIN create the popup menu for programs, and display it
        text_show_args = _("Show history for \"") + item.data.short_name() + "\""
        popup_menu_of_action_panel.addItem(
            text_show_args,
            loader.loadIconSet( "clock"
                                , kdecore.KIcon.Desktop
                                , size_of_small_icons_in_popup_menus * resolution_multiplier), 
            item_data = ("Show files used with", item.data))


        if isinstance(item.data, custom_mime_program):
            popup_menu_of_action_panel.addItem(
                _("Delete \"")  + item.data.name() + "\"" ,
                loader.loadIconSet( "button_cancel"
                                    , kdecore.KIcon.Desktop
                                    , size_of_small_icons_in_popup_menus * resolution_multiplier), 
                item_data = ("Delete", item.data))
            
        if item.data.usage_count() > 0:
            popup_menu_of_action_panel.addItem(
                _("Forget that \"") + item.data.short_name() + _("\" was ever used"),
                loader.loadIconSet( "undo"
                                    , kdecore.KIcon.Desktop
                                    , size_of_small_icons_in_popup_menus * resolution_multiplier),
                item_data = ("Forget this has been used", item.data))

        if isinstance(item.data, verb):
            popup_menu_of_action_panel.addItem(
                _("Help about \"")   + item.data.name() + "\"",
                loader.loadIconSet( "help"
                                    , kdecore.KIcon.Desktop
                                    , size_of_small_icons_in_popup_menus * resolution_multiplier),
                item_data = ("Help", item.data))


        popup_menu_of_action_panel.popup(qt.QCursor.pos())
        # END
        
    elif button_meaning == "enter folder":

        files_tab_widget.showPage(vbox['file'])

        cur_dir_watcher.removeDir(cur_dir)
        cur_dir_watcher.addDir(item.data)


        cur_dir = item.data
        find_free_space_in_folder(cur_dir)
        os.chdir(cur_dir)

        update_goto_parent_button()
        mainWindow.setCaption(cur_dir)
        filterQuickText['file'].clear() # sic! not of the history panel.
        time_frozen = time.gmtime()
        # BEGIN update the stats of the newly entered directory
        usage_count_of_file[cur_dir] = usage_count_of_file.get(cur_dir, 0) + 1
        last_usage_time_of_file[cur_dir] = time_frozen

        fi = find(arguments_used_with_any_program,
                  lambda pair: pair.name == cur_dir)
        if fi ==None:
            arguments_used_with_any_program.append(
                argument_info(cur_dir,1, time_frozen))
        else:
            arguments_used_with_any_program.remove( fi)
            arguments_used_with_any_program.append(
                argument_info(cur_dir, fi.usage_count +1,
                              time_frozen))

        # END

        # BEGIN Sic! getSortingCriterion is an english string. _()
        #       must be applied afterwards
        cr = _(sorting_criterion_for_dir.get(cur_dir, "Recent usage"))
        # END
        sortBox['file'].setCurrentText(cr) # SIC! not of hist panel. Bug fixed.
        redraw_files()
        if narrow_history_tabbar.currentTab() != id_of_tab_show_all:
            narrow_history_tabbar.setCurrentTab(show_everything_in_hist_panel)       # calls redraw_history()
        else:
            redraw_history() # we must call it directly
    else:
        print "not managed"


def on_item_chosen_from_hist_or_file_popup_menu(menu, item_data):
    global cur_dir, selected_actions
    global program_focused_in_history
    
    (action_meaning, action_arg) = item_data
    if action_meaning == "Select":
        print "old code"
   

#         extens_before = types_selected_for_prog_narrowing()
#         to_be_released = action_arg in selected_files

#         if to_be_released:
#             if action_arg == cur_dir:
#                 locationButton.setPressedState(False)
#             selected_files.remove(action_arg)
#         else:
#             if action_arg == cur_dir:
#                 locationButton.setPressedState(True)
#             selected_files.append(action_arg)

#         update_info_bar()
        
#         if to_be_released:
#             if action_arg in files_selected_in_the_history_panel:
#                 files_selected_in_the_history_panel.remove(action_arg)
#         else:
#             if menu == popup_menu_of_history_panel:
#                 files_selected_in_the_history_panel.add(action_arg)


#         # BEGIN if there is no action yet, add a default one
#         if selected_actions == []:
#             mimeprograms = ( mime_programs_that_can_manage_some_file__classes
#                              +
#                              [custom_mime_program(c) for c in custom_mime_programs])


#             progs_that_can_manage_selected_files = [x for x in mimeprograms
#                                                     if  forall(types_selected_for_prog_narrowing(),
#                                                                lambda t: x.can_manage_type(t)) ]
#             print "len = " + str(len(progs_that_can_manage_selected_files))
#             if progs_that_can_manage_selected_files != []:
#                 p = best_element(
#                     set = progs_that_can_manage_selected_files,
#                     better_than = lambda f1, f2: f1.last_usage_time() > f2.last_usage_time())
#                 selected_actions = [p]
#                 a_default_action_has_been_chosen = True
#             else:
#                 a_default_action_has_been_chosen = False
#         else:
#             a_default_action_has_been_chosen = False
            
#         # END
                
#         # BEGIN we have to synchronize the light bulbs of the other
#         # panel
#         listBox['argument'].set_pressed_state_of_textitem(
#             pressed = not to_be_released , item_data = action_arg)
#         listBox['file'].set_pressed_state_of_textitem(
#             pressed = not to_be_released , item_data = action_arg)
#         listBox['file'].make_changes_visible()
#         listBox['argument'].make_changes_visible() # update the bulbs
#         # END
#         extens_after = types_selected_for_prog_narrowing()
#         if len(extens_after) != len(extens_before) or a_default_action_has_been_chosen:
#             redraw_programs(remember_scroll = False)
#             listBox['program'].flash_all_items(config.gFlashingTimeForList )
            
#         update_clear_simple_cmd_button()
#         redraw_simple_command_area()

 
#     elif action_meaning == "Set as current dir":

#         os.chdir(action_arg)
#         bar_that_displays_the_current_bash_dir.setText(_("Working directory: ") + action_arg)
#         QToolTip.add(bar_that_displays_the_current_bash_dir,
#                      action_arg + _("\n\nThis is the current working directory for shell commands."))

#     elif action_meaning == "Copy to command area with full path":


        
        
#         t = make_string_bash_compatible(action_arg)
#         commandEntry.insert(t + "  ")
#         commandEntry.setFocus()
#         commandEntry.startFlashing(3, True)

#     elif action_meaning == "Copy to command area":


#         t = make_string_bash_compatible(os.path.basename(action_arg))
#         commandEntry.insert(t + "  ")
#         commandEntry.setFocus()
#         commandEntry.startFlashing(3, True)
    elif action_meaning == "Hide category":
        list_item_data = action_arg
        if list_item_data == "removable section of history panel":
            program_focused_in_history = None
            listBox['argument'].flash_all_items(config.gFlashingTimeForList)
            redraw_history(remember_scroll = False)
        else:
            QMessageBox.information(mainVBox, _("Not removable."), _("This category cannot be hidden."))
    else:
        QMessageBox.information(mainVBox, _("Not implemented."), _("This feature has not yet been implemented."))


QObject.connect(popup_menu_of_history_panel,
                PYSIGNAL("itemActivated"),
                on_item_chosen_from_hist_or_file_popup_menu)
QObject.connect(popup_menu_of_file_panel,
                PYSIGNAL("itemActivated"),
                on_item_chosen_from_hist_or_file_popup_menu)



def update_clear_simple_cmd_button():
    should_be_enabled =  (selected_files != [] or selected_actions != [])
    if should_be_enabled != clear_simple_cmd_button.isEnabled():
        clear_simple_cmd_button.setEnabled(should_be_enabled)


def create_window_list():
    global the_window_list_has_been_deleted, windowlist_window, windowlist_help_label, windowlist_vbox
    global windowlist_help_hbox, windowlist_default_message, cancel_drag_button, sortBox
    global filterBox, filterButton, filterClearButton, filterQuickText, filterMenu
    global listBox
    global on_cancel_drag, on_drag_activate , on_close_terminals_pressed
    windowlist_window = MyListWindow(mainWindow)
    windowlist_window.setCaption("Window list")

    windowlist_vbox = QVBox(windowlist_window)
    windowlist_vbox.show()
    windowlist_vbox.setSpacing(spacing)
    windowlist_window.setCentralWidget(windowlist_vbox)


    windowlist_help_hbox = QHBox(windowlist_vbox)
    windowlist_help_hbox.setMargin(spacing * 2.0)
    windowlist_help_hbox.setPaletteBackgroundColor(windowlist_help_hbox.palette().active().mid())
    windowlist_help_hbox.setFrameStyle(QFrame.StyledPanel | QFrame.Sunken)
    windowlist_help_hbox.setSpacing(spacing)
    windowlist_help_hbox.show()
    windowlist_default_message = _("Click an item below to activate the corresponding window.")
    windowlist_help_label = FlashingLabel( windowlist_default_message
                                           , windowlist_help_hbox)
    windowlist_help_label.setAlignment(Qt.AlignCenter |Qt.AlignVCenter)
    windowlist_help_label.startFlashing(config.gFlashingTimeForHelpMessage
                                        , resetOriginalColorsWhenFinished = True)


    cancel_drag_button=QPushButton(QIconSet(QPixmap(config.imgDir + "delete.png"))
                                   , _("Cancel drag")
                                   , windowlist_help_hbox)
    cancel_drag_button.setSizePolicy(QSizePolicy.Fixed, QSizePolicy.Minimum)
    cancel_drag_button.hide()

    def on_cancel_drag():
        global dragging_state
        dragging_state = 'no-drag'
        cancel_drag_button.hide()
        windowlist_help_label.setText(windowlist_default_message)
        windowlist_help_label.startFlashing(config.gFlashingTimeForHelpMessage
                                            , resetOriginalColorsWhenFinished = True)
    k = 'window'
    
    QObject.connect(cancel_drag_button, SIGNAL("clicked()"), on_cancel_drag)
    listBox['window'] = MyListBox(frameVisible = True, parent = windowlist_vbox
                              , resolution_mult = resolution_multiplier
                              , up_pixm = up_pixm
                              , top_pixm = top_pixm
                              , down_pixm = down_pixm
                              , bottom_pixm = bottom_pixm)
    listBox[k].show()
#     QObject.connect(listBox[k], PYSIGNAL("item_button_released"), on_list_item_button_released)
#     QObject.connect(listBox[k], PYSIGNAL("item_togglebutton_pressed"), on_list_item_togglebutton_pressed)
#     QObject.connect(listBox[k], PYSIGNAL("item_togglebutton_released"), on_list_item_togglebutton_released)
    QObject.connect(listBox[k], PYSIGNAL("item_pressed"), on_list_item_pressed)
    QObject.connect(listBox[k], PYSIGNAL("item_released"), on_list_item_released)

    def on_drag_activate(wid):
        # simply activate the window and restart a new drag
        windowlist_window.hide()
        windowlist_help_label.setText(windowlist_default_message)
        print "activating window " + str(wid)
        kdecore.KWin.forceActiveWindow(wid)
    
    QObject.connect(listBox['window']
                    , PYSIGNAL("drag_activate")
                    , on_drag_activate)


    sortBox['window'] = MyComboBox(windowlist_vbox)
    sortBox['window'].show()
    sortBox['window'].insertItem(config.imgDir + "clock-small.png", _("Creation date"), "Date")
    QObject.connect(sortBox['window'], PYSIGNAL("itemActivated"), onSortBoxItemActivated)
    if pykde_supports_wid:
        sortBox['window'].insertItem(config.imgDir + "stock_timer.png", _("Recent usage"), "Recent usage")


    if not pykde_supports_wid:
        sortBox['window'].setCurrentText(_("Creation date"))
    else:
        sortBox['window'].setCurrentText(_("Recent usage"))



    #

    filterBox[k] = QHBox(windowlist_vbox)
    filterBox[k].show()
    filterBox[k].setSpacing(3) # @@ TODO: scale?

    filterClearButton[k] = QPushButton(filterBox[k])
    filterClearButton[k].show()
    filterClearButton[k].setIconSet(QIconSet(QPixmap(config.imgDir + 'delete-right.png')))
    filterClearButton[k].setSizePolicy(QSizePolicy.Fixed, QSizePolicy.Minimum)

    filterQuickText[k] = MyLineEdit(filterBox[k])
    filterQuickText[k].show()
    QObject.connect(filterQuickText[k]
                    , PYSIGNAL("timer"), onFilterKeyTimer)
    QObject.connect( filterQuickText[k]
                     , SIGNAL("returnPressed()")
                     , onEnterPressedOnFilter )

    filterButton[k] = QPushButton(
        QIconSet(QPixmap(config.imgDir + "mbuto.png")),
        _("Recent filters"), filterBox[k])
    filterButton[k].show()

    filterMenu[k] = MyPopupMenu(filterButton[k])
    QObject.connect(filterMenu[k]
                    , PYSIGNAL("itemActivated"), onRecentFilterClicked)
    filterButton[k].setPopup(filterMenu[k])
    QObject.connect(filterClearButton['window']
                    , SIGNAL("clicked()"), clearWindowFiltersAndUpdate)
    #


    windowlist_toolbar = QToolBar(windowlist_window) 
    windowlist_toolbar.show()

    def on_close_terminals_pressed():
        print "on_close_terminals_pressed"
        for w in windows_sorted_by_creation_date:
            def is_probably_terminated(w):
                def strip_parent(s):
                    print "strip_parent: input: " + s
                    assert len(s)>=2
                    l = len(s)
                    s2 =  s[1:l-1]
                    print "strip_parent: output: " + s2
                    return s2
                def all_digits(s):
                    return forall(s, lambda c: c in digits)
                inf = kdecore.KWin.windowInfo(w)
                nam = str(inf.visibleName())
                print "nam = " + nam
                list = re.findall( r"<\D*?>" ,  nam)
                return is_substring_of('konsole', nam) and len(list)>0 

            print "--"
            if is_probably_terminated(w):
                print "sending quit signal to window " + str(w)
                os.kill(pid(w), signal.SIGKILL)
                # a better way would be:
                #     ri = kdecore.NETRootInfo( qt_xdisplay(),  kdecore.NET.CloseWindow );
                #     ri.closeWindowRequest( w );
                # but it doesn't work... @@ TODO


    close_terminals_button = QToolButton(loader.loadIconSet( "konsole"
                                                             , kdecore.KIcon.Small
                                                             , 16)
                                         , _("Close terminated output windows")
                                         , "unused"
                                         , on_close_terminals_pressed
                                         , windowlist_toolbar)
    close_terminals_button.setMinimumHeight(height_of_toolbar_buttons)
    close_terminals_button.setUsesTextLabel(True)
    close_terminals_button.setTextPosition(QToolButton.BesideIcon)
    QToolTip.add(close_terminals_button
                 , _("Closes all konsole windows whose associated command is terminated."))


    #
    def on_focus_onefinger_clicked():
        kdecore.KWin.activateWindow(mainWindow.winId())

    focus_onefinger_button = QToolButton(QIconSet(QPixmap(config.imgDir + "onefinger.png"))
                                         , _("Activate OneFinger")
                                         , "unused"
                                         , on_focus_onefinger_clicked
                                         , windowlist_toolbar)
    focus_onefinger_button.setMinimumHeight(height_of_toolbar_buttons)
    QToolTip.add(focus_onefinger_button
                 , _("Focus the main OneFinger window. However, the quickest way to do this\nis to right-click the panel applet."))


    #


    the_window_list_has_been_deleted = False
    



mainVBox = QVBox(mainWindow)
mainVBox.show()
mainVBox.setMargin(spacing)
mainVBox.setSpacing(spacing)
mainWindow.setCentralWidget(mainVBox)



#misc_toolbar = QToolBar(mainWindow)
#misc_toolbar.setHorizontallyStretchable(True)
#misc_toolbar.show()


height_of_toolbar_buttons = int (33.0 * resolution_multiplier)
height_of_execute_buttons = int (50.0 * resolution_multiplier)




loader = kdecore.KIconLoader()

#




#







#









def save_database():
    # BEGIN write database
    print "Saving database..."
    persistence.dumpToFile(targetFile = config.dataDir + 'windowlist_x'
                           , var = windowlist_x)
    persistence.dumpToFile(targetFile = config.dataDir + 'g_show_menu_buttons'
                           , var = g_show_menu_buttons)

    persistence.dumpToFile(targetFile = config.dataDir + 'custom_mime_programs'
                           , var = custom_mime_programs)
    persistence.dumpToFile(targetFile = config.dataDir + 'readable_name_of_custom_mime_program'
                           , var = readable_name_of_custom_mime_program)
    persistence.dumpToFile(targetFile = config.dataDir + 'windowlist_y'
                           , var = windowlist_y)
    persistence.dumpToFile(targetFile = config.dataDir + 'windowlist_wt'
                           , var = windowlist_wt)
    persistence.dumpToFile(targetFile = config.dataDir + 'windowlist_ht'
                           , var = windowlist_ht)
    persistence.dumpToFile(targetFile = config.dataDir + 'program_runs_in_terminal'
                           , var = program_runs_in_terminal)
    persistence.dumpToFile(targetFile = config.dataDir + 'cur_dir', var = cur_dir)
    persistence.dumpToFile(targetFile = config.dataDir + 'favorite_files'
                           , var = favorite_files)
    persistence.dumpToFile(targetFile = config.dataDir + 'types_used_with_cli_program',
                           var = types_used_with_cli_program)
    persistence.dumpToFile(targetFile = config.dataDir + 'types_used_with_mime_program',
                           var = types_used_with_mime_program)
    persistence.dumpToFile(targetFile = config.dataDir + 'types_used_with_custom_mime_program',
                           var = types_used_with_custom_mime_program)
    
    persistence.dumpToFile(targetFile = config.dataDir + 'types_usable_with_custom_mime_program',
                           var = types_usable_with_custom_mime_program)

    persistence.dumpToFile(targetFile = config.dataDir + 'usage_count_of_cli_program'
                           , var = usage_count_of_cli_program)
    persistence.dumpToFile(targetFile = config.dataDir + 'usage_count_of_mime_program'
                           , var = usage_count_of_mime_program)
    persistence.dumpToFile(targetFile = config.dataDir + 'usage_count_of_custom_mime_program'
                           , var = usage_count_of_custom_mime_program)
    persistence.dumpToFile(targetFile = config.dataDir + 'usage_count_of_file'
                           , var = usage_count_of_file)
    persistence.dumpToFile(targetFile = config.dataDir + 'usage_count_of_verb'
                           , var = usage_count_of_verb)

    persistence.dumpToFile(targetFile = config.dataDir + 'arguments_of_cli_program'
                           , var = arguments_of_cli_program)
    persistence.dumpToFile(targetFile = config.dataDir + 'arguments_of_mime_program'
                           , var = arguments_of_mime_program)
    persistence.dumpToFile(targetFile = config.dataDir + 'arguments_of_custom_mime_program'
                           , var = arguments_of_custom_mime_program)
    persistence.dumpToFile(targetFile = config.dataDir + 'arguments_of_verb'
                           , var = arguments_of_verb)

    persistence.dumpToFile(targetFile = config.dataDir + 'recent_filters'
                           , var = recent_filters)

    persistence.dumpToFile(targetFile = config.dataDir + 'last_usage_time_of_file'
                           , var = last_usage_time_of_file)
    persistence.dumpToFile(targetFile = config.dataDir + 'last_usage_time_of_verb'
                           , var = last_usage_time_of_verb)
    persistence.dumpToFile(targetFile = config.dataDir + 'last_usage_time_of_mime_program'
                           , var = last_usage_time_of_mime_program)
    persistence.dumpToFile(targetFile = config.dataDir + 'last_usage_time_of_custom_mime_program'
                           , var = last_usage_time_of_custom_mime_program)
    persistence.dumpToFile(targetFile = config.dataDir + 'last_usage_time_of_cli_program'
                           , var = last_usage_time_of_cli_program)
    
    persistence.dumpToFile(targetFile = config.dataDir
                           + 'sorting_criterion_for_dir'
                           , var = sorting_criterion_for_dir)
    persistence.dumpToFile(targetFile = config.dataDir
                           + 'help_bar_visible', var = help_bar_visible)
    persistence.dumpToFile(targetFile = config.dataDir
                           + 'sorting_criterion_for_arguments'
                           , var = sorting_criterion_for_arguments)
    persistence.dumpToFile(targetFile = config.dataDir + 'sorting_criterion_for_programs'
                           , var = sorting_criterion_for_programs)
    persistence.dumpToFile(targetFile = config.dataDir + 'arguments_used_with_any_program'
                           , var = arguments_used_with_any_program)
    persistence.dumpToFile(targetFile = config.dataDir + 'show_full_paths_in_history'
                           , var = show_full_paths_in_history)
    persistence.dumpToFile(targetFile = config.dataDir + 'newbie_labels_visible'
                           , var = newbie_labels_visible)

    print "Database saving completed."
    # END





#
def deselect_all_files_and_actions():
    global selected_files, files_selected_in_the_history_panel, selected_actions
    global program_focused_in_history
    selected_files = []
    selected_actions = []
    files_selected_in_the_history_panel.clear()
    program_focused_in_history = None
    update_info_bar()
    redraw_files()
    redraw_history()
    redraw_programs(remember_scroll = False)
    redraw_simple_command_area()
    
    listBox['file'].flash_all_items(config.gFlashingTimeForList)
    listBox['argument'].flash_all_items(config.gFlashingTimeForList)
    listBox['program'].flash_all_items(config.gFlashingTimeForList)
    
    clear_simple_cmd_button.setEnabled(False)





#





#



#

# class DragTargetButtonForUnicodeUri(QToolButton):
#     def __init__(self, iconset, text, callback, parent ):
#         QToolButton.__init__(self, iconset, text, "group text - unused", callback, parent)
#         self.setAcceptDrops(True)
#     def dragEnterEvent(self, event):
#         event.accept(  QUriDrag.canDecode(event) or QTextDrag.canDecode(event))
#     def dropEvent(self, event):
#         print "dropEvent"
#         l = QStringList()
#         s = QString()
#         if  QUriDrag.decodeToUnicodeUris(event, l):
#             print "accept. l = " + str(l)
#             event.acceptAction()
#             for i in l:
#                 commandEntry.insert("\"" + str(i) + "\"  ")
#         elif  QTextDrag.decode(event, s):
#             print "accept. l = " + str(s)
#             event.acceptAction()
#             commandEntry.insert("\"" + str(s) + "\"")
#         else:
#             event.acceptAction(False)


# def on_drag_button_pressed():
#     QMessageBox.information(mainVBox, _("Drag and drop"),

#                             _("This button is only here for dragging files onto it. Anything you\ndrag on it will be copied in the command area, in an appropriate\nformat (takes care of quoting, etc.)."  ))

# drop_target = DragTargetButtonForUnicodeUri(QIconSet(QPixmap(config.imgDir + "stock_drag-mode.png"))
#                                             , _("Drop here")
#                                             , on_drag_button_pressed
#                                             , misc_toolbar)
# drop_target.setMinimumHeight(height_of_toolbar_buttons)
# drop_target.show()
# drop_target.setUsesTextLabel(True)
# drop_target.setTextPosition(QToolButton.BesideIcon)
# QToolTip.add(drop_target,

# _("You can drop files, directories, http and ftp locations onto\nthis button. They will be copied into the command area in an\nappropriate format, so you can use them as part of a command."))


#QObject.connect(drop_target, SIGNAL("clicked()"), on_drag_button_pressed)




#

# def on_drag_to_clicked():
#     if  selected_files == []:
#         QMessageBox.critical(mainVBox,
#                              _("Drag error - no file selected")

# ,_("The button you have pushed is for dragging files (or URIs) from\nOneFinger to another window. First, select some files for dragging.\nThen, press the button."))
#     else:
#         global dragging_state
#         dragging_state = dragging_state_waiting_for_window(selected_files)

#         rebuild_window_list_if_it_was_deleted()
#         cancel_drag_button.show() 
#         windowlist_window.move(QPoint(windowlist_x, windowlist_y))
#         windowlist_window.show()
#         kdecore.KWin.forceActiveWindow(windowlist_window.winId())
#         # BEGIN hack to remove the highlighted item @@
#         listBox['window'].lastMousePos = None
#         listBox['window'].make_changes_visible() 
#         # END
#         windowlist_help_label.setText(_("Click the window you want to drag the files to."))
#         windowlist_help_label.startFlashing(config.gFlashingTimeForHelpMessage
#                                             , resetOriginalColorsWhenFinished = True)

# drag_to_button = FlashingToolButton(QIconSet(QPixmap(config.imgDir + "stock_drag-mode.png"))
#                                     , _("Drag to...")
#                                     , "unused"
#                                     , on_drag_to_clicked
#                                     , misc_toolbar)
# drag_to_button.setEnabled(False)
# if cli_mode:
#     drag_to_button.show()
# else:
#     drag_to_button.hide()
# drag_to_button.setMinimumHeight(height_of_toolbar_buttons)
# drag_to_button.setUsesTextLabel(True)
# drag_to_button.setTextPosition(QToolButton.BesideIcon)
        
        
# QToolTip.add(drag_to_button,
             
#  _("This button is for dragging files (or URIs) from OneFinger to another\nwindow. First, select some files for dragging by clicking their \"drag\nicon\"; then press this button. You'll be asked for the target window,\nwhich will be automatically activated."))















#

def on_popup_menu_of_horiz_list__item_activated(menu, item):
    global selected_actions, program_focused_in_history
    
    if (  isinstance(item, mime_program)
          or isinstance(item, custom_mime_program)
          or isinstance(item, verb) ):

        selected_actions = []

        
        scroll_must_be_remembered_for_history_panel = (program_focused_in_history == None)
        program_focused_in_history = None
        redraw_programs(remember_scroll = False)
        redraw_history(remember_scroll = scroll_must_be_remembered_for_history_panel)
        listBox['program'].flash_all_items(config.gFlashingTimeForList )

    else:
        

        # we have to deselect the file "item"
        extens_before = types_selected_for_prog_narrowing()

        if item == cur_dir:
            locationButton.setPressedState(False)
        selected_files.remove(item)

        update_info_bar()
        
        if item in files_selected_in_the_history_panel:
            files_selected_in_the_history_panel.remove(item)


        # BEGIN 
        listBox['argument'].set_pressed_state_of_textitem(
            pressed = False , item_data = item)
        listBox['file'].set_pressed_state_of_textitem(
            pressed = False, item_data = item)
        listBox['file'].make_changes_visible()
        listBox['argument'].make_changes_visible()
        # END

        extens_after = types_selected_for_prog_narrowing()

        if len(extens_after) != len(extens_before):
            redraw_programs(remember_scroll = False)
            listBox['program'].flash_all_items(config.gFlashingTimeForList )


        update_clear_simple_cmd_button()


    redraw_simple_command_area()
    update_clear_simple_cmd_button()

popup_menu_of_horiz_list = MyPopupMenu(mainWindow)
QObject.connect(popup_menu_of_horiz_list,
                PYSIGNAL("itemActivated"),
                on_popup_menu_of_horiz_list__item_activated)












#


def on_command_mode_changed(widg):
    global shell_mode

    print "on_command_mode_changed"
    shell_mode = not widg is simple_command_hbox

    
command_tab_widget = QTabWidget(mainVBox)
QObject.connect(command_tab_widget, SIGNAL("currentChanged ( QWidget * )"), on_command_mode_changed)

command_tab_widget.setMargin(spacing)
command_tab_widget.setSizePolicy(QSizePolicy.Minimum, QSizePolicy.Minimum)
simple_command_hbox = QHBox(command_tab_widget)
command_tab_widget.addTab(simple_command_hbox, "Simple command")

simple_command_hbox.setSpacing(spacing)
simple_command_hbox.show()
    
clear_simple_cmd_button = QPushButton( simple_command_hbox)
clear_simple_cmd_button.setPixmap(QPixmap(config.imgDir + "delete-right-big.png"))
clear_simple_cmd_button.setMinimumSize( int(44.0 * resolution_multiplier)
                                     , int(32.0 * resolution_multiplier))

clear_simple_cmd_button.setSizePolicy(QSizePolicy.Fixed, QSizePolicy.Minimum)

QObject.connect(clear_simple_cmd_button, SIGNAL("clicked()"), deselect_all_files_and_actions)
update_clear_simple_cmd_button()




horiz_list = HorizListOfButtons(simple_command_hbox,
                                minimum_button_wt = 32.0 * resolution_multiplier,
                                message_empty = _("<the command is empty>"))
horiz_list.show()





def on_horiz_list_item_pressed(list, item):
    popup_menu_of_horiz_list.clear()
    popup_menu_of_horiz_list.addItem(
        _("Remove from command"),
        loader.loadIconSet( "down"
                            , kdecore.KIcon.Desktop
                            , size_of_big_icons_in_popup_menus * resolution_multiplier),
        item_data = item)
    popup_menu_of_horiz_list.popup(qt.QCursor.pos())
    
QObject.connect(horiz_list, PYSIGNAL("horiz_list_item_pressed"),
                on_horiz_list_item_pressed)


exec_simp_cmd_pix =  loader.loadIcon( "cache"
                                      , kdecore.KIcon.Small)

execute_simple_cmd_button = FlashingPushButton(QIconSet(exec_simp_cmd_pix)
                                               , _("Execute")
                                               , simple_command_hbox)
execute_simple_cmd_button.setSizePolicy(QSizePolicy.Fixed, QSizePolicy.Minimum)
execute_simple_cmd_button.show()
execute_simple_cmd_button.setMinimumWidth(150.0 * resolution_multiplier)
QToolTip.add(execute_simple_cmd_button,
             _("Execute the command you have composed."))

     

def on_execute_simple_cmd_button_pressed():
    execute_selected_program_with_selected_files()

QObject.connect(execute_simple_cmd_button, SIGNAL("clicked()"), on_execute_simple_cmd_button_pressed)








#
def update_info_bar( ):

    if free_space_in_cur_dir:
        free_space_label = _("Free space: ") + str(free_space_in_cur_dir) + "  -  "
    else:
        free_space_label = ""
        
    if selected_files != []:
        size = reduce(lambda x, y: x + y,
                      [os.path.getsize(f) for f in selected_files],
                      0)
        help_label.setText( free_space_label + str(len(selected_files)) + _(" files selected, ") + str(kio.KIO.convertSize(size )) )
    else:
        help_label.setText( free_space_label + _("No file selected."))




#








mainMenuBar = qt.QMenuBar(mainWindow)
mainMenuBar.show()



file_menu = qt.QPopupMenu(mainMenuBar)
view_menu = qt.QPopupMenu(mainMenuBar)
view_menu.setCheckable(True)


mainMenuBar.insertItem( _("&File"), file_menu)
mainMenuBar.insertItem( _("&View"), view_menu)



#


def on_purge_clicked():
    global usage_count_of_file, arguments_of_cli_program, arguments_used_with_any_program
    global last_usage_time_of_file, sorting_criterion_for_dir

    global arguments_of_verb, arguments_of_mime_program

    files_tab_widget.showPage(vbox['argument'])

    
    for x in usage_count_of_file.keys():
        if not os.path.exists(x):
            print "usage_count_of_file: removing " + x
            del usage_count_of_file[x]
    assert forall(usage_count_of_file.keys()
                  , lambda k:  os.path.exists(k))
    
    for x in last_usage_time_of_file.keys():
        if not os.path.exists(x):
            print "last_usage_time_of_file: removing " + x
            del last_usage_time_of_file[x]
    assert forall(last_usage_time_of_file.keys()
                  , lambda k:  os.path.exists(k))

    for x in sorting_criterion_for_dir.keys():
        if not os.path.exists(x):
            print "sorting_criterion_for_dir: removing " + x
            del sorting_criterion_for_dir[x]
    assert forall(sorting_criterion_for_dir.keys()
                  , lambda k:  os.path.exists(k))

    arguments_used_with_any_program = [ a for a in arguments_used_with_any_program
                                        if ( a.name[0] != '/'
                                             or
                                             os.path.exists(a.name))]

    for p in arguments_of_cli_program.keys():
        arguments_of_cli_program[p] = [a for a in arguments_of_cli_program[p]
                                   if ( a.name[0] != '/' or os.path.exists(a.name))]
    for p in arguments_of_verb.keys():
        arguments_of_verb[p] = [a for a in arguments_of_verb[p]
                                   if ( os.path.exists(a.name))]
    for p in arguments_of_mime_program.keys():
        arguments_of_mime_program[p] = [a for a in arguments_of_mime_program[p]
                                   if ( os.path.exists(a.name))]
        
    redraw_history()
    listBox['argument'].flash_all_items(config.gFlashingTimeForList)



file_menu.insertItem(
    QIconSet(QPixmap(config.imgDir + "stock_toilet-paper.png")),
    _("Purge database"),
    on_purge_clicked)

def on_rescan_programs_chosen():
        rescan_programs(display_wait_message = True)
        redraw_programs(remember_scroll = False)
        listBox['program'].flash_all_items(config.gFlashingTimeForList)

file_menu.insertItem(
    loader.loadIconSet( "reload"
                        , kdecore.KIcon.Small),
    _("Rescan installed programs"),
    on_rescan_programs_chosen)





#QObject.connect(file_menu, SIGNAL("activated(int)"), on_file_menu_item_chosen)

file_menu.insertItem( 
    loader.loadIconSet( "filesave"
                        , kdecore.KIcon.Small),
    _("Save database"),
    save_database)


def on_quit_chosen():
    applic.quit()

file_menu.insertItem( 
    loader.loadIconSet( "exit"
                        , kdecore.KIcon.Small),
    _("Quit"),
    on_quit_chosen)




def on_show_newb_labels_toggled():
    global newbie_labels_visible

    newbie_labels_visible = not newbie_labels_visible
    view_menu.setItemChecked(1, newbie_labels_visible) # @@
    label['files'].setShown(newbie_labels_visible)
    label['programs'].setShown(newbie_labels_visible)




view_menu.insertItem( _("Panel titles"), on_show_newb_labels_toggled)

def on_show_help_clicked():
    global help_bar_visible

    if help_bar_visible:
        help_hbox.hide()
        help_bar_visible = False
    else:
        help_hbox.show()
        help_bar_visible = True
        


view_menu.insertItem( _("Status bar"), on_show_help_clicked)

view_menu.setItemChecked(1, newbie_labels_visible) # @@


def on_show_adv_controls():
    global g_show_menu_buttons
    g_show_menu_buttons = not g_show_menu_buttons
    redraw_programs(remember_scroll = True)

view_menu.insertItem( _("Advanced controls"), on_show_adv_controls)










mainGrid = QGrid(2, mainVBox)
mainGrid.setSpacing(spacing * 2)
mainGrid.setMargin(spacing)
mainGrid.show()





hBoxSpacing = 3

cli_programs_that_can_manage_some_file__classes = []
mime_programs_that_can_manage_some_file__classes = []
rescan_programs() # writes cli_programs_installed__classes, icon_of_cli_program,
                  # types_usable_with_cli_program, cli_programs_that_can_manage_some_file__classes,
                  # mime_programs_that_can_manage_some_file__classes, ...

string_result = QString()
apply_pixmap = loader.loadIcon("edit_add", kdecore.KIcon.Small
                               , 0
                               , kdecore.KIcon.DefaultState
                               , string_result
                               , True)
if apply_pixmap.isNull():
    apply_pixmap = loader.loadIcon("apply", kdecore.KIcon.Small)


# LABEL ROW


for k in [ 'programs', 'files']:
    label[k] = QLabel(mainGrid)
    label[k].setAlignment(Qt.AlignCenter |Qt.AlignVCenter)
    label[k].setShown(newbie_labels_visible)


label['files'].setText(_('Files'))
label['programs'].setText(_('Actions'))




# Create the structure

vbox['program'] = QVBox(mainGrid)

files_tab_widget = QTabWidget(mainGrid)
files_tab_widget.setMargin(spacing)


vbox['file'] = QVBox(files_tab_widget)
vbox['argument'] = QVBox(files_tab_widget)
files_tab_widget.addTab(vbox['file'],
#                         loader.loadIconSet( "folder"
#                                             , kdecore.KIcon.Desktop
#                                             , 32 * resolution_multiplier),

                        "Current folder")
files_tab_widget.addTab(vbox['argument'],
#                         loader.loadIconSet( "clock"
#                                             , kdecore.KIcon.Desktop
#                                             , 32 * resolution_multiplier),
                            
                        "History")

for k in [ 'file', 'program', 'argument']:
    vbox[k].setSpacing(spacing)
    vbox[k].show()


# FILL THE vboxes


for k in [ 'file', 'program', 'argument']:

    hBox[k] = QHBox(vbox[k])
    hBox[k].setSpacing(hBoxSpacing)
    hBox[k].show()







current_dir_icon = qt.QLabel(hBox['file'])
current_dir_icon.setSizePolicy(QSizePolicy.Fixed, QSizePolicy.Minimum)
current_dir_icon.setPixmap(file_to_icon(cur_dir, 16))
current_dir_icon.show()


#def on_current_dir_changed():
#    os.chdir(cur_dir)

#QObject.connect(set_current_dir_button, SIGNAL("clicked()"), on_current_dir_changed)
#set_current_dir_button.setSizePolicy(QSizePolicy.Fixed, QSizePolicy.Minimum)
#QToolTip.add(set_current_dir_button,

#_("Set this directory as the current bash \"working directory\". \nThis is only useful in \"shell mode\". Changing the working directory is needed\nbecause it influences the behavior of some programs, such as cvs.\nUsing this button is like typing \"cd <dir>\" before executing a command."))






locationButton = TruncatingButton('text will change', hBox['file']
                                  , data = None)

QObject.connect(locationButton, PYSIGNAL("pressed")
                , onLocationButtonPressed) 

locationButton.show()

QToolTip.add(locationButton,
_("The folder that is currently visible in the file panel (below)."))


#
select_pattern_button = QPushButton( loader.loadIconSet( "wizard"
                                                         , kdecore.KIcon.Small)
                                     , ""
                                     , hBox['file'])
select_pattern_button.show()
select_pattern_button.setSizePolicy(QSizePolicy.Fixed, QSizePolicy.Minimum)
QToolTip.add(select_pattern_button, _("Select files based on a pattern. You can also use this button to select all files."))

def on_select_pattern_pressed():
    global selected_files, files_selected_in_the_history_panel
    tx, ok = qt.QInputDialog.getText(_("Select files by pattern")
                                     , _("Please type the pattern representing the files to be selected. \nLeave the \"*\" to select all.")
                                     , qt.QLineEdit.Normal
                                     , "*")
    if ok:
        ss = u'python ' + unicode(config.parser_file_dir) + u'/parser.py \"' + unicode(cur_dir) + u"\"/" + unicode(tx) 
        fil =   os.popen( ss, 'r')
        lines = fil.readlines()
        fil.close()
        selected_files = [string.strip(x) for x in lines[1:]]
        files_selected_in_the_history_panel.clear()
        redraw_files(centering = True)
        update_info_bar()
        redraw_history(remember_scroll = True)
        redraw_programs(remember_scroll = False)
        update_clear_simple_cmd_button()
        redraw_simple_command_area()



QObject.connect(select_pattern_button, SIGNAL("clicked()"), on_select_pattern_pressed)



#

go_to_parent_dir_button = QPushButton( loader.loadIconSet( "up"
                                                           , kdecore.KIcon.Small)
                                       , ""
                                       , hBox['file'])
go_to_parent_dir_button.show()
go_to_parent_dir_button.setSizePolicy(QSizePolicy.Fixed, QSizePolicy.Minimum)


msg =_("Go to the parent folder. Please note that there is another way\nto go to the parent folder: in the history panel, locate the parent\nfolder, click it, then click the \"door\" icon.")


QToolTip.add(go_to_parent_dir_button, msg)

def update_goto_parent_button():
    go_to_parent_dir_button.setEnabled(cur_dir != '/')

def on_goto_parent_pressed():
    global cur_dir

    # BEGIN update stats needed to make the old dir appear in the history
    time_frozen = time.gmtime()
    usage_count_of_file[cur_dir] = usage_count_of_file.get(cur_dir, 0) + 1
    last_usage_time_of_file[cur_dir] = time_frozen
    fi = find(arguments_used_with_any_program,
              lambda pair: pair.name == cur_dir)
    if fi ==None:
        arguments_used_with_any_program.append(
            argument_info(cur_dir,1, time_frozen))
    else:
        arguments_used_with_any_program.remove( fi)
        arguments_used_with_any_program.append(
            argument_info(cur_dir, fi.usage_count +1,
                          time_frozen))
    # END

    cur_dir = os.path.dirname(cur_dir)
    os.chdir(cur_dir)
    find_free_space_in_folder(cur_dir)


    # BEGIN Sic! getSortingCriterion is an english string. _()
    #       must be applied afterwards
    cr = _(sorting_criterion_for_dir.get(cur_dir, "Recent usage"))
    # END
    
    sortBox['file'].setCurrentText(cr) # SIC! not of hist panel. Bug fixed.

    redraw_files(centering = False) # @@ TODO: focus on the directory you just were in.
    redraw_history(remember_scroll = False)
    update_goto_parent_button()
    
        
QObject.connect(go_to_parent_dir_button, SIGNAL("clicked()"), on_goto_parent_pressed)




#






    

#rescan_programs_tooltip = {True:
#             _("Rescan programs. Click here when you have installed or removed a program, or if the $PATH has changed. \nIt rescans the $PATH and the MIME associations.")
#                           , False:
#
#                           _("Rescan programs. Click here when you have installed or removed a program, in order\nto see it in the program panel.")}






#argument_label = FlashingLabel(_('History'), hBox['argument'])
#argument_label.show()
#icon['argument'].setPixmap(loader.loadIcon(  "colors"
#                                             , kdecore.KIcon.Small))

#QToolTip.add(argument_label,
#        
#_("The history panel (below) contains a list of files and options used\nat least once. This panel is very versatile: it can be set to show only\nthe arguments passed to a given program, or the most recent files used\nwith any program, the most frequently used options, and much more."))





#


def on_tab_changed(tab_id):
    global program_focused_in_history, last_tab_selected

    if tab_id != last_tab_selected:
        last_tab_selected = tab_id

        if tab_id != id_of_tab_show_all:
            must_redraw_programs = program_focused_in_history != None
            program_focused_in_history = None
            if must_redraw_programs:
                redraw_programs(remember_scroll = True)

        
        redraw_history()
        
narrow_history_tabbar = qt.QTabBar(hBox['argument'])
narrow_history_tabbar.show()
QObject.connect(narrow_history_tabbar, SIGNAL("selected ( int  )"), on_tab_changed)






show_everything_in_hist_panel = qt.QTab(_("All"))
id_of_tab_show_all = narrow_history_tabbar.addTab(show_everything_in_hist_panel)
narrow_history_tabbar.setCurrentTab(show_everything_in_hist_panel)

# QToolTip.add(show_everything_in_hist_panel
# , _("Show everything in the history panel."))


# def on_show_everything_in_hist_panel_toggled(on):
#     if on:
#         listBox['argument'].flash_all_items(config.gFlashingTimeForList)
#         redraw_history()
# QObject.connect(show_everything_in_hist_panel
#                 , SIGNAL("toggled(bool)"),
#                 on_show_everything_in_hist_panel_toggled)







only_show_important_dirs_in_arg_panel_button = qt.QTab(_("Favorites"))
id_of_tab_show_fav = narrow_history_tabbar.addTab(only_show_important_dirs_in_arg_panel_button)


# QToolTip.add(only_show_important_dirs_in_arg_panel_button

# , _("Only show favorites in the history panel. Use this to quickly\nfind an important file or folder. You should definitely learn to\nuse this button."))

# def on_only_show_important_dirs_in_arg_panel_button_toggled(on):
#     global program_focused_in_history
#     if on:

#         must_redraw_programs = program_focused_in_history != None
#         program_focused_in_history = None
#         if must_redraw_programs:
#             redraw_programs(remember_scroll = True)


#         listBox['argument'].flash_all_items(config.gFlashingTimeForList)
#         redraw_history()

# QObject.connect(only_show_important_dirs_in_arg_panel_button
#                 , SIGNAL("toggled(bool)")
#                 , on_only_show_important_dirs_in_arg_panel_button_toggled)


#

only_show_dirs_in_arg_panel_button = qt.QTab(_("Folders"))
id_of_tab_show_dirs = narrow_history_tabbar.addTab(only_show_dirs_in_arg_panel_button)

# QToolTip.add(only_show_dirs_in_arg_panel_button
#              , _("Only show folders in this panel. Use this when you need to\nquickly find a recent folder (usually to enter it)."))

# def on_only_show_dirs_in_arg_panel_button_toggled(on):
#     global program_focused_in_history
#     if on:

        
#         must_redraw_programs = program_focused_in_history != None
#         program_focused_in_history = None
#         if must_redraw_programs:
#             redraw_programs(remember_scroll = True)

        
#         listBox['argument'].flash_all_items(config.gFlashingTimeForList)
#         redraw_history()

# QObject.connect(only_show_dirs_in_arg_panel_button
#                 , SIGNAL("toggled(bool)")
#                 , on_only_show_dirs_in_arg_panel_button_toggled)



#


only_show_files_in_arg_panel_button = qt.QTab(   _("Files") )
id_of_tab_show_files = narrow_history_tabbar.addTab(only_show_files_in_arg_panel_button)

# QToolTip.add(only_show_files_in_arg_panel_button

# , _("Only show files in this panel (i.e. hide options and folders)."))

# def on_only_show_files_in_arg_panel_button_toggled(on):
#     global program_focused_in_history
#     if on:

#         must_redraw_programs = program_focused_in_history != None
#         program_focused_in_history = None
#         if must_redraw_programs:
#             redraw_programs(remember_scroll = True)

        
#         listBox['argument'].flash_all_items(config.gFlashingTimeForList)
#         redraw_history()

# QObject.connect(only_show_files_in_arg_panel_button, SIGNAL("toggled(bool)")
#                 , on_only_show_files_in_arg_panel_button_toggled)

#
only_show_options_in_arg_panel_button = qt.QTab(_("Options"))
id_of_tab_show_opt = narrow_history_tabbar.addTab(only_show_options_in_arg_panel_button)


# QToolTip.add(only_show_options_in_arg_panel_button

# , _("Only show \"program options\" in this panel (i.e. hide files and folders)."))

# def on_only_show_options_in_arg_panel_button_toggled(on):
#     global program_focused_in_history
#     if on:

#         must_redraw_programs = program_focused_in_history != None
#         program_focused_in_history = None
#         if must_redraw_programs:
#             redraw_programs(remember_scroll = True)


#         listBox['argument'].flash_all_items(config.gFlashingTimeForList)
#         redraw_history()

        
# QObject.connect(only_show_options_in_arg_panel_button, SIGNAL("toggled(bool)")
#                 , on_only_show_options_in_arg_panel_button_toggled)


#

# @@
# def on_show_args_with_any_program_clicked():
#     global program_focused_in_history
#     program_focused_in_history = None
#     show_arguments_with_any_program_button.setEnabled(False)
#     listBox['argument'].flash_all_items(config.gFlashingTimeForList)
#     redraw_history()
#     redraw_programs(remember_scroll = True) # only to update the appearance of the toggle buttons @@



#

def on_show_full_path_toggled(on):
    global show_full_paths_in_history
    show_full_paths_in_history = on
    redraw_history(remember_scroll = True) 
    listBox['argument'].flash_all_items(config.gFlashingTimeForList)
show_full_paths_in_history_iconset = QIconSet(QPixmap(config.imgDir + "full-path.png"))

show_full_paths_in_history_button = QPushButton( show_full_paths_in_history_iconset
                                                 , _("")
                                                 , hBox['argument'])
show_full_paths_in_history_button.setSizePolicy(QSizePolicy.Fixed, QSizePolicy.Minimum)
show_full_paths_in_history_button.setMinimumWidth(
    int(config.width_of_scroll_buttons * resolution_multiplier))
show_full_paths_in_history_button.show()
show_full_paths_in_history_button.setToggleButton(True)
QToolTip.add(show_full_paths_in_history_button,
             _("Show full paths in the history panel. Useful if you have two files with\nthe same name, that differ only by their path."))

show_full_paths_in_history_button.setOn(show_full_paths_in_history) 
                                
QObject.connect(show_full_paths_in_history_button
                , SIGNAL("toggled(bool)"), on_show_full_path_toggled)



    

#


# SECOND ROW

    
def on_list_item_togglebutton_released(list, item, button_meaning):
    global selected_files, files_selected_in_the_history_panel
    k = find([ 'file', 'program', 'argument'], lambda x: listBox[x] is list)
    if button_meaning == "select file and narrow programs":
        extens_before = types_selected_for_prog_narrowing()
        selected_files.remove(item.data)
        if item.data in files_selected_in_the_history_panel:
            #print "calling files_selected_in_the_history_panel.remove"
            files_selected_in_the_history_panel.remove(item.data)
        # BEGIN we have to synchronize the light bulbs of the other panel :-(
        if k == 'file':
            listBox['argument'].set_pushbutton_of_textitem(
                button_meaning = button_meaning
                , pressed = False , item_data = item.data)
        else:
            listBox['file'].set_pushbutton_of_textitem(
                button_meaning = button_meaning
                , pressed = False , item_data = item.data)
        listBox['file'].make_changes_visible()
        listBox['argument'].make_changes_visible() # update the bulb

        # END
        extens_after = types_selected_for_prog_narrowing()
        if len(extens_after) < len(extens_before):
            redraw_programs(remember_scroll = False)
            listBox['program'].flash_all_items(config.gFlashingTimeForList)
            
        update_clear_simple_cmd_button()

    elif k == 'program':
        global program_focused_in_history
        program_focused_in_history = None
        redraw_history()
        redraw_programs(remember_scroll = True) # only to update the
                                                # pressed button. The
                                                # speed could be
                                                # improved. @@
        listBox['argument'].flash_all_items(config.gFlashingTimeForList)

    else:
        raise "by god"


# @@ test if this is still called
def on_list_item_button_released(list, item, button_meaning):
    if button_meaning == "bring on top":
        win_pid = pid(item.data)
        util_windows_to_bring_on_top = [q for q in windows_sorted_by_creation_date
                                        if pid(q) == win_pid
                                        if is_utility_window(q)]
        for x in util_windows_to_bring_on_top:
            kdecore.KWin.activateWindow(x)
        kdecore.KWin.activateWindow(item.data)
        kdecore.KWin.forceActiveWindow(windowlist_window.winId())
        #redraw_windows(remember_scroll = True, 

def make_string_bash_compatible(f):
    t = string.replace(f, '\"', '\"')
    return '\"' + f + '\"'




def execute_selected_program_with_selected_files():
    global selected_files, favorite_files, selected_actions
    global files_to_copy, files_to_move
    global files_selected_in_the_history_panel
    global program_focused_in_history

    if selected_actions == []:
        QMessageBox.information(
            mainVBox
            , _("Error")
            , _("You have not specified what action you want to execute.\nClick an action, then click \"Add to command\"."  ))

    else:
        prog_to_exec = selected_actions[0]

        def compute_command_line_for_program(raw_exec_string):
            def quote(x):
                return "\"" + x + "\""
            selquote = [quote(x) for x in selected_files]
            concatenated_files = reduce(lambda x, y: x + " " + y
                                        , selquote
                                        , "")
            i_have_to_append_the_files_brutally = not ( is_substring_of('%f', raw_exec_string)
                                                        or
                                                        is_substring_of('%F', raw_exec_string)
                                                        or
                                                        is_substring_of('%u', raw_exec_string)
                                                        or
                                                        is_substring_of('%U', raw_exec_string))
            if i_have_to_append_the_files_brutally:
                exec5 = raw_exec_string + " " + concatenated_files
                print "I am appending the filenames brutally at the end"
            else:
                exec2 = string.replace(raw_exec_string, '%f', concatenated_files)
                exec3 = string.replace(exec2, '%F', concatenated_files)
                exec4 = string.replace(exec3, '%u', concatenated_files)
                exec5 = string.replace(exec4, '%U', concatenated_files)
            return exec5


        def deselect_all():
            global selected_files, files_selected_in_the_history_panel, selected_actions
            global program_focused_in_history
            selected_files = []
            program_focused_in_history = None
            files_selected_in_the_history_panel.clear()
            clear_simple_cmd_button.setEnabled(False)
            selected_actions = []
            update_info_bar()

        def redraw_files_resetting_scrolling_if_necessary():
            tx = sortBox['file'].currentText()
            redraw_files(centering = (tx != _("Recent usage")))

        # in mime mode, we have to execute the verb or
        # mime_program that was clicked.

        def depress_arg_narrowing_buttons_and_redraw_history():
            print "depress"
            if narrow_history_tabbar.currentTab() != id_of_tab_show_all:
                narrow_history_tabbar.setCurrentTab(show_everything_in_hist_panel) # callback to redraw_history
            else:
                redraw_history() # we have to redraw directly

        if isinstance(prog_to_exec, verb):

            # BEGIN update stats for files and programs. We do
            # this first because after the verb is executed we may
            # or may not redraw the panels. If we do, stats must
            # have already been updated.
            time_frozen = time.gmtime()
            # BEGIN increase stats for files
            for f in selected_files:
                usage_count_of_file[f] = usage_count_of_file.get(f,0) +1
                last_usage_time_of_file[f] = time_frozen
            # END
            # BEGIN set statistics concerning verb
            verb_name = prog_to_exec.name()
            usage_count_of_verb[verb_name] = usage_count_of_verb.get(
                verb_name, 0) +1
            last_usage_time_of_verb[verb_name] = time_frozen

            if arguments_of_verb.get(verb_name, None) == None:
                arguments_of_verb[verb_name] = []

            for a in selected_files:
                fi = find(arguments_of_verb[verb_name],
                          lambda pair: pair.name == a)
                if fi ==None:
                    arguments_of_verb[verb_name].append(
                        argument_info(a,1, time_frozen))
                else:
                    arguments_of_verb[verb_name].remove( fi)
                    arguments_of_verb[verb_name].append(
                        argument_info(a, fi.usage_count +1,
                                      time_frozen))
            # END

            # BEGIN remember arguments used with ANY program (not
            # p)
            for a in selected_files:
                fi = find(arguments_used_with_any_program,
                          lambda pair: pair.name == a)
                if fi ==None:
                    arguments_used_with_any_program.append(
                        argument_info(a,1, time_frozen))
                else:
                    arguments_used_with_any_program.remove( fi)
                    arguments_used_with_any_program.append(
                        argument_info(a, fi.usage_count +1,
                                      time_frozen))

            # END

            # END update stats


            if prog_to_exec.name() == _('Properties'):
                if len(selected_files) ==0:
                    QMessageBox.information(
                        mainVBox
                        , _("Error")
                        , _("Please select one or more files."  ))
                elif len(selected_files) == 1:
                    kfile.KPropertiesDialog(
                        kdecore.KURL(selected_files[0])
                        , mainVBox)
                else:
                    kfile.KPropertiesDialog(
                        [kio.KFileItem(kio.KFileItem.Unknown
                                       , kio.KFileItem.Unknown
                                       , kdecore.KURL(f))
                         for f in selected_files] 
                        , mainVBox)

                deselect_all()
                redraw_files_resetting_scrolling_if_necessary() # also updates icon (folder with heart)
                depress_arg_narrowing_buttons_and_redraw_history() # show the new icon for that dir.

            elif prog_to_exec.name() == _('Search folder'):
                if not (len(selected_files) ==1 and os.path.isdir(selected_files[0])):
                    QMessageBox.information(
                        mainVBox
                        , _("Error")
                        , _("Please select exactly one folder to search."  ))
                else:
                    os.system("kfind \"" + selected_files[0] + "\" &")

                deselect_all()
                redraw_files_resetting_scrolling_if_necessary()
                depress_arg_narrowing_buttons_and_redraw_history() # show the new icon for that dir.
            elif prog_to_exec.name() == _('Open terminal here'):
                if not (len(selected_files) ==1 and os.path.isdir(selected_files[0])):
                    QMessageBox.information(
                        mainVBox
                        , _("Error")
                        , _("Please select exactly one folder."  ))
                else:
                    os.system("konsole --workdir \"" + selected_files[0] + "\" &")

                deselect_all()
                redraw_files_resetting_scrolling_if_necessary()
                depress_arg_narrowing_buttons_and_redraw_history() # show the new icon for that dir.
            elif prog_to_exec.name() == _('Open with custom command line'):

                if len(selected_files) != 1:
                    QMessageBox.information(
                        mainVBox
                        , _("Error")
                        , _("Please select exactly one file or folder."  ))

                else:

                    text = _("In this window you can create a custom\naction. This is useful to execute a program which\ndoes not appear in the program panel, or if it\nappears but you want to execute it with some\nprecise options (like \"-subfont small\"). Please\nenter the command line for the custom action you\nwant to create. If you insert %f in the command,\nit will be replaced by OneFinger with the selected\nfiles. Examples: mplayer %f -vo sdl \n konsole --noclose -e scp -r %f foo@shell.sf.net/htdocs/ ")
                    res = qt.QInputDialog.getText( _("Custom action editor")
                                                   , text
                                                   , qt.QLineEdit.Normal , "" , mainWindow)
                    (command, ok) = res

                    if ok:
                        text = _("Now insert a name for the new action.") 
                        res = qt.QInputDialog.getText( _("Insert name for the new action")
                                                       , text
                                                       , qt.QLineEdit.Normal , "" , mainWindow)
                        (name, ok) = res
                        if ok:
                            custom_mime_programs.append(str(command))
                            readable_name_of_custom_mime_program[str(command)] = str(name)

                            # BEGIN find the type of the selected file
                            url = kdecore.KURL()
                            url.setFileName(selected_files[0])

                            file_item = kio.KFileItem(kio.KFileItem.Unknown
                                                      , kio.KFileItem.Unknown
                                                      , url)
                            type = str(file_item.mimetype())
                            # END
                            types_usable_with_custom_mime_program[str(command)] = Set([type])

                            QMessageBox.information(
                                mainVBox
                                , _("Action created successfully")
                                , _("You can find the new action in the program panel, in the group\n\"Can manage " + type + ", never used\". If you click it, it will be executed.")  )

                    else:
                        print "rejected"


            elif prog_to_exec.name() == _('Add to favorites'):

                to_add  = [ f for f in selected_files if not f in favorite_files]
                if len(to_add)>0:
                    favorite_files = favorite_files + to_add
                    deselect_all()
                    redraw_files_resetting_scrolling_if_necessary()
                    depress_arg_narrowing_buttons_and_redraw_history() # show the new icon for that dir.
                else:
                    QMessageBox.information(
                        mainVBox
                        , _("Information")
                        , _("All the selected files were already marked as favorites. Nothing was done."  ))
            elif prog_to_exec.name() == _('Remove from favorites'):
                if '/' in selected_files:
                    QMessageBox.information(
                        mainVBox
                        , _("Information")
                        , _("The / folder is special and cannot be removed from the favorites. Nothing will be done."  ))
                else:

                    to_remove  = [ f for f in selected_files if f in favorite_files]
                    if len(to_remove)>0:
                        for qq in to_remove:
                            favorite_files.remove(qq)
                        deselect_all()
                        redraw_files_resetting_scrolling_if_necessary()
                        depress_arg_narrowing_buttons_and_redraw_history() # show the new icon for that dir.
                    else:
                        QMessageBox.information(
                            mainVBox
                            , _("Information")
                            , _("The selected files were not favorites. Nothing was done."  ))

            elif prog_to_exec.name() == _('Execute program'):
                if len(selected_files) == 0:
                    QMessageBox.information(
                        mainVBox
                        , _("Error")
                        , _("Please select an executable file."  ))
                elif len(selected_files) >1:
                    QMessageBox.information(
                        mainVBox
                        , _("Error")
                        , _("Please select only one executable file."  ))
                else:
                    f = selected_files[0]
                    if not os.access(f, os.X_OK):
                        QMessageBox.information(
                            mainVBox
                            , _("Error")
                            , _("You do not have sufficient rights to execute this file."  ))
                    else:
                        os.system( f + " &" )
                        deselect_all()
                        redraw_files_resetting_scrolling_if_necessary()
                        depress_arg_narrowing_buttons_and_redraw_history() 

            elif prog_to_exec.name() == _("Cut files"):
                if len(selected_files) == 0:
                    QMessageBox.information(
                        mainVBox
                        , _("Error")
                        , _("Please select at least one file."  ))
                else:
                    files_to_move = selected_files
                    files_to_copy = []
                    deselect_all()
                    redraw_files_resetting_scrolling_if_necessary()
                    depress_arg_narrowing_buttons_and_redraw_history() 
            elif prog_to_exec.name() == _("Copy files"):
                if len(selected_files) == 0:
                    QMessageBox.information(
                        mainVBox
                        , _("Error")
                        , _("Please select at least one file."  ))
                else:
                    files_to_copy = selected_files
                    files_to_move = []
                    deselect_all()
                    redraw_files_resetting_scrolling_if_necessary()
                    depress_arg_narrowing_buttons_and_redraw_history() 

            elif prog_to_exec.name() == _("Paste link here"):
                def files_to_link():
                    assert files_to_move != [] or files_to_copy != []
                    if files_to_move == []:
                        return files_to_copy
                    else:
                        return files_to_move

                if files_to_move == [] and files_to_copy == []:
                     QMessageBox.information(
                        mainVBox
                        , _("Error")
                        , _("To put a link to one or more files in a folder F, first select the files and click \"Copy files\". \nThen select F and click \"Paste link here\"."  ))
                elif len(selected_files) != 1 or exists(selected_files, lambda f: not os.path.isdir(f)):
                     QMessageBox.information(
                        mainVBox
                        , _("Error")
                        , _("You have to select exactly one folder where the links will be placed."  ))

                elif exists(files_to_link(),
                            lambda f: os.path.normpath(selected_files[0]) == os.path.normpath(os.path.dirname(f))):
                     QMessageBox.information(
                        mainVBox
                        , _("Error")
                        , _("You cannot put a link to a file in the same folder as the file."  ))

                else:
                    target_dir = selected_files[0]

                    url_list = QStringList()
                    for x in files_to_link():
                        url_list.append(x)

                    dest_url = kdecore.KURL()
                    dest_url.setFileName(target_dir)

                    kio.KIO.link(kdecore.KURL.List(url_list), dest_url)

                    files_to_move = []
                    files_to_copy = []
                    deselect_all()
                    redraw_files_resetting_scrolling_if_necessary()
                    depress_arg_narrowing_buttons_and_redraw_history()

            elif prog_to_exec.name() == _("Create new folder here"):
                if ( len(selected_files)!= 1
                     or exists(selected_files, lambda f: not os.path.isdir(f))):

                    QMessageBox.information(
                        mainVBox
                        , _("Error")
                        , _("Please select exactly one folder as the container for the new folder."  ))
                else:
                    tx, ok = qt.QInputDialog.getText(_("Create folder")
                                                     , _("Please type the name of the folder to be created.")
                                                     , qt.QLineEdit.Normal
                                                     , "new folder")
                    if ok:
                        dir_url = kdecore.KURL()
                        dir_url.setFileName(selected_files[0] + "/" + unicode(tx))

                        kio.KIO.mkdir(dir_url)

                        deselect_all()
                        redraw_files_resetting_scrolling_if_necessary()
                        depress_arg_narrowing_buttons_and_redraw_history() 

            elif prog_to_exec.name() == _("Paste files here"):
                if ( len(selected_files)!= 1
                     or exists(selected_files, lambda f: not os.path.isdir(f))):

                    QMessageBox.information(
                        mainVBox
                        , _("Error")
                        , _("Please select exactly one folder as the destination."  ))
                else:
                    def cleanup_after_successful_copy_or_move():
                        global files_to_copy, files_to_move
                        
                        files_to_move = []
                        files_to_copy = []
                        deselect_all()
                        redraw_files_resetting_scrolling_if_necessary()
                        depress_arg_narrowing_buttons_and_redraw_history()
                        
                    if files_to_move != []:

                        strlist = QStringList()
                        for x in files_to_move:
                            strlist.append(x)

                        copyjob = kio.KIO.move(kdecore.KURL.List(strlist)
                                               , kdecore.KURL(selected_files[0]))
                        cleanup_after_successful_copy_or_move()
                    elif  files_to_copy != []:

                        strlist = QStringList()
                        for x in files_to_copy:
                            strlist.append(x)

                        copyjob = kio.KIO.copy(kdecore.KURL.List(strlist)
                                               , kdecore.KURL(selected_files[0]))
                        cleanup_after_successful_copy_or_move()
                    else:
                        QMessageBox.information(
                            mainVBox
                            , _("Error")
                            , _("A paste operation must be preceded by a cut or copy operation."  ))
                        
            elif prog_to_exec.name() == _("Move files to trash"):


                if len(selected_files)==0:
                    QMessageBox.information(
                        mainVBox
                        , _("Error")
                        , _("Please select at least one file."  ))
                else:

                    # @@ try KIO.trash first! Only available in KDE
                    # cvs, but does not move the file acros
                    # filesystems

                    strlist = QStringList()
                    for x in selected_files:
                        strlist.append(x)

                    try:
                        copyjob = kio.KIO.trash(kdecore.KURL.List(strlist))
                    except:

                        trash_path = kdecore.KGlobalSettings.trashPath()
                        trash_path_u = unicode(trash_path)
                        if not os.path.isdir(trash_path_u):
                            os.makedirs(trash_path_u)

                        copyjob = kio.KIO.move(kdecore.KURL.List(strlist)
                                               , kdecore.KURL(trash_path))

                    deselect_all()
                    redraw_files_resetting_scrolling_if_necessary()
                    depress_arg_narrowing_buttons_and_redraw_history() 
            elif prog_to_exec.name() == _("Drag to window"):
                if len(selected_files)==0:
                    QMessageBox.information(
                        mainVBox
                        , _("Error")
                        , _("Please select at least one file to drag."  ))
                else:
                    global dragging_state
                    dragging_state = dragging_state_waiting_for_window(selected_files)

                    deselect_all() # too dangerous to leave
                                   # selected. The user may select
                                   # a file without realizing the
                                   # just-dragged folder is still
                                   # selected, and delete it.

                    rebuild_window_list_if_it_was_deleted()
                    cancel_drag_button.show()
                    windowlist_window.move(QPoint(windowlist_x, windowlist_y))
                    windowlist_window.show()
                    kdecore.KWin.forceActiveWindow(windowlist_window.winId())
                    # BEGIN hack to remove the highlighted item @@
                    listBox['window'].lastMousePos = None
                    listBox['window'].make_changes_visible() 
                    # END
                    windowlist_help_label.setText(_("Click the window you want to drag the files to."))
                    windowlist_help_label.startFlashing(config.gFlashingTimeForHelpMessage
                                                        , resetOriginalColorsWhenFinished = True)

                    redraw_files_resetting_scrolling_if_necessary()

                    depress_arg_narrowing_buttons_and_redraw_history()

            elif prog_to_exec.name() == _("Delete files"):
                if len(selected_files)==0:
                    QMessageBox.information(
                        mainVBox
                        , _("Error")
                        , _("Please select at least one file to delete."  ))
                else:
                    num = str(len(selected_files))
                    res = QMessageBox.question(mainVBox
                                               , _('Confirmation')
                                               , _('Are you sure you want to delete ') + num + _(' files?')
                                               , QMessageBox.Yes, QMessageBox.No)
                    if res == QMessageBox.Yes:

                        strlist = QStringList()
                        for x in selected_files:
                            strlist.append(x)

                        copyjob = kio.KIO.del_(kdecore.KURL.List(strlist))

                        deselect_all()
                        redraw_files_resetting_scrolling_if_necessary()
                        depress_arg_narrowing_buttons_and_redraw_history()

                    else:
                        print "error in PyQt"
                        print str(res) + str(QMessageBox.Yes) + str(QMessageBox.No)
                        

            else:
                QMessageBox.information(
                    mainVBox
                    , _("Information")
                    , _("Action not yet implemented. In the meantime, please use the shell mode.\n(You can activate shell mode with the first button in the toolbar.)"  ))

        else: # a program was executed

            assert isinstance(prog_to_exec, custom_mime_program) or  isinstance(prog_to_exec, mime_program)

            raw_exec = prog_to_exec.raw_exec_string()
            print "raw_exec = " + raw_exec

            if isinstance(prog_to_exec, custom_mime_program):
                cmd_with_files = compute_command_line_for_program(raw_exec)
                os.system(cmd_with_files + " &")
            else:
                # BEGIN execute with kde
                strlist = QStringList()
                for x in selected_files:
                    strlist.append(x)

                kdecore.KApplication.startServiceByDesktopPath(
                    desktop_file_of_mime_program[raw_exec]
                    , strlist)
                # END


            # BEGIN update stats for files and programs

            time_frozen = time.gmtime()
            # BEGIN increase stats for files
            for f in selected_files:
                usage_count_of_file[f] = usage_count_of_file.get(f,0) +1
                last_usage_time_of_file[f] = time_frozen
            # END
            # BEGIN set statistics concerning program
            prog = prog_to_exec
            prog.increase_usage_count()
            prog.set_last_usage_time(time_frozen)

            if len(prog.arguments_used()) == 0:
                prog.set_arguments_used([])

            for a in selected_files:
                fi = find(prog.arguments_used(),
                          lambda pair: pair.name == a)
                if fi ==None:
                    prog.arguments_used().append(
                        argument_info(a,1, time_frozen))
                else:
                    prog.arguments_used().remove( fi)
                    prog.arguments_used().append(
                        argument_info(a, fi.usage_count +1,
                                      time_frozen))

            #

            if len (prog.types_used() ) == 0:
                prog.set_types_used(Set())
            for f in selected_files:
                url = kdecore.KURL()
                url.setFileName(f)

                file_item = kio.KFileItem(kio.KFileItem.Unknown
                                          , kio.KFileItem.Unknown
                                          , url)
                type = file_item.mimetype()
                prog.types_used().add(str(type))

            # END

            # BEGIN remember arguments used with ANY program (not
            # p)
            for a in selected_files:
                fi = find(arguments_used_with_any_program,
                          lambda pair: pair.name == a)
                if fi ==None:
                    arguments_used_with_any_program.append(
                        argument_info(a,1, time_frozen))
                else:
                    arguments_used_with_any_program.remove( fi)
                    arguments_used_with_any_program.append(
                        argument_info(a, fi.usage_count +1,
                                      time_frozen))

            # END
            filterQuickText['program'].setText("")
            program_focused_in_history = None
            selected_files = []
            update_info_bar()
            selected_actions = []
            files_selected_in_the_history_panel.clear()
            clear_simple_cmd_button.setEnabled(False)
            #drag_to_button.setEnabled(False)
            redraw_files_resetting_scrolling_if_necessary()
            depress_arg_narrowing_buttons_and_redraw_history()
            # END

        # BEGIN in any case, redraw the program panel
        redraw_programs(remember_scroll = False)
        redraw_simple_command_area()
        rebuild_progs_that_can_manage_some_file()
        # END

def text_item_clicked(file_name, clicked_from_history_panel):

    global selected_actions
    
    if shell_mode:

        t = make_string_bash_compatible(file_name)
        commandEntry.insert(t + "  ")
        commandEntry.setFocus()
        #commandEntry.startFlashing(3, True)

    else:

        if not os.path.exists(file_name):
            command_tab_widget.showPage(bash_command_hbox) # this runs a callback that sets shell_mode
            t = make_string_bash_compatible(file_name)
            commandEntry.insert(t + "  ")
            commandEntry.setFocus()

        else:

            extens_before = types_selected_for_prog_narrowing()
            to_be_released = file_name in selected_files

            if to_be_released:
                if file_name == cur_dir:
                    locationButton.setPressedState(False)
                selected_files.remove(file_name)
            else:
                if file_name == cur_dir:
                    locationButton.setPressedState(True)
                selected_files.append(file_name)

            update_info_bar()

            if to_be_released:
                if file_name in files_selected_in_the_history_panel:
                    files_selected_in_the_history_panel.remove(file_name)
            else:
                if clicked_from_history_panel:
                    files_selected_in_the_history_panel.add(file_name)


            # BEGIN if there is no action yet, add a default one
            if not to_be_released:
                if selected_actions == []:
                    if ( ( files_to_copy != [] or files_to_move != [] )
                         and
                         len(selected_files) ==1
                         and
                         os.path.isdir(selected_files[0])):

                        selected_actions = [ v for v in verbs_wrapped if v.name() == "Paste files here" ]
                        a_default_action_has_been_chosen = True
                    else:

                        mimeprograms = ( mime_programs_that_can_manage_some_file__classes
                                         +
                                         [custom_mime_program(c) for c in custom_mime_programs])


                        progs_that_can_manage_selected_files = [x for x in mimeprograms
                                                                if  forall(types_selected_for_prog_narrowing(),
                                                                           lambda t: x.can_manage_type(t)) ]
                        if progs_that_can_manage_selected_files != []:
                            p = best_element(
                                set = progs_that_can_manage_selected_files,
                                better_than = lambda f1, f2: f1.last_usage_time() > f2.last_usage_time())
                            selected_actions = [p]
                            a_default_action_has_been_chosen = True
                        else:
                            a_default_action_has_been_chosen = False
                else:
                    a_default_action_has_been_chosen = False

            # END

            # BEGIN we have to synchronize the light bulbs of the other
            # panel
            listBox['argument'].set_pressed_state_of_textitem(
                pressed = not to_be_released , item_data = file_name)
            listBox['file'].set_pressed_state_of_textitem(
                pressed = not to_be_released , item_data = file_name)
            listBox['file'].make_changes_visible()
            listBox['argument'].make_changes_visible() # update the bulbs
            # END
            extens_after = types_selected_for_prog_narrowing()
            if len(extens_after) != len(extens_before) or a_default_action_has_been_chosen:
                redraw_programs(remember_scroll = False)
                listBox['program'].flash_all_items(config.gFlashingTimeForList )

            update_clear_simple_cmd_button()
            redraw_simple_command_area()



def on_list_item_pressed(box, item):
    global last_usage_time_of_file, last_usage_time_of_mime_program
    global last_usage_time_of_verb, usage_count_of_file
    global usage_count_of_verb, usage_count_of_mime_program
    global arguments_used_with_any_program, program_focused_in_history
    global favorite_files, files_to_copy, files_to_move
    global selected_files, custom_mime_programs, readable_name_of_custom_mime_program
    global types_usable_with_custom_mime_program
    global selected_actions


    
    k = find( [ 'file', 'program', 'argument', 'window']
              , lambda x: listBox[x] is box )
    
    #if k != 'window':  # @@
    #    commandEntry.startFlashing( 3, True )

    

    if k == 'program':

        popup_menu_of_action_panel.clear()

        if isinstance(item, TextSeparator):

            popup_menu_of_action_panel.addItem(
                _("Hide this category"),
                loader.loadIconSet( "cancel"
                                    , kdecore.KIcon.Desktop
                                    ,  size_of_small_icons_in_popup_menus * resolution_multiplier),
                item_data = ("Hide category", item.data))

            popup_menu_of_action_panel.popup(qt.QCursor.pos())

        else:
            assert isinstance(item, TextItem)
            
            if selected_files == []:  # the user selected a program first
                files_tab_widget.showPage(vbox['argument'])


            if isinstance(item.data, cli_program):

                if not shell_mode:
                    command_tab_widget.showPage(bash_command_hbox)

                commandEntry.insert( item.data.raw_exec_string() + "  " ) # fires on_text_changed
        
                if len(files_selected_in_the_history_panel) == 0:
                    program_focused_in_history = item.data

                    # BEGIN DON'T DO THIS! It is the job of on_text_changed to
                    # flash the file listbox; doing this here would only result in
                    # duplicated redrawing of the file list.
                    #
                    #if the_string_specifies_a_program(...) == False:
                    #listBox['file'].startFlashing(config.gFlashingTimeForList,
                    #                             resetOriginalColorsWhenFinished = True)
                    #redraw_files(centering = True)
                    #
                    #END

                    listBox['argument'].flash_all_items(config.gFlashingTimeForList)
                    redraw_history() # @@ only if history visible! speedup.
                    redraw_programs(remember_scroll = True) # @@ only to update the pressed button
                
            else:

                if shell_mode:
                    command_tab_widget.showPage(simple_command_hbox)

                
                if selected_actions != [] and selected_actions[0] == item.data:
                    selected_actions = []
                    program_focused_in_history = None
                else:
                    # BEGIN this replaces the previously selected program, if any
                    selected_actions = [ item.data ]
                    # END
                    program_focused_in_history = item.data
                    
                redraw_history(remember_scroll = False) # @@ only if history visible! speedup.
                listBox['argument'].flash_all_items(config.gFlashingTimeForList)
            
                redraw_programs(remember_scroll = True)
                redraw_simple_command_area()
                update_clear_simple_cmd_button()

                
    elif k == 'argument' or k == 'file':
        if k == 'argument':
            popup_men = popup_menu_of_history_panel
        else:
            popup_men = popup_menu_of_file_panel
            
        if isinstance(item, TextSeparator):
            popup_men.clear()
            popup_men.addItem(
                _("Hide this category"),
                loader.loadIconSet( "cancel"
                                    , kdecore.KIcon.Desktop
                                    ,  size_of_small_icons_in_popup_menus * resolution_multiplier),
                item_data = ("Hide category", item.data))

            popup_men.popup(qt.QCursor.pos())
        else:
            assert isinstance(item, TextItem)

            text_item_clicked(file_name = item.data,
                              clicked_from_history_panel = (k == 'argument'))

                
    elif k == 'window':
        pass # wait for mouse release, otherwise a spurious click is
             # detected by the new window

            
        
    commandEntry.setFocus()


def on_list_item_released(box, item):
    global dragging_state
    k = find([ 'file', 'program','argument', 'window'], lambda x: listBox[x] is box)
    if k == 'window':
        if isinstance(dragging_state, dragging_state_waiting_for_window):
            files = dragging_state.sel_files
            dragging_state = 'no-drag'
            cancel_drag_button.hide()
            windowlist_window.hide()
            windowlist_help_label.setText(windowlist_default_message)
            kdecore.KWin.activateWindow(item.data)
            d = QUriDrag(files, mainWindow)
            d.dragCopy() 

        elif dragging_state == 'no-drag':
            win_pid = pid(item.data)
            util_windows_to_bring_on_top = [q for q in windows_sorted_by_creation_date
                                            if pid(q) == win_pid
                                            if is_utility_window(q)]
            # BEGIN before activating! Otherwise the last activated
            # window looses the focus!
            windowlist_window.hide()
            # END
            for x in util_windows_to_bring_on_top:
                kdecore.KWin.activateWindow(x)
            kdecore.KWin.activateWindow(item.data)
        else:
            raise "dammit"


pix_size = 16
up_pixm = loader.loadIcon( "up"
                           , kdecore.KIcon.Small
                           , pix_size)
top_pixm = loader.loadIcon( "top"
                           , kdecore.KIcon.Small
                           , pix_size)
bottom_pixm = loader.loadIcon( "bottom"
                           , kdecore.KIcon.Small
                           , pix_size)
down_pixm = loader.loadIcon( "down"
                           , kdecore.KIcon.Small
                           , pix_size)

for k in ["argument",  "file", "program" ]:
    listBox[k] = MyListBox(frameVisible = True,
                           parent = vbox[k]
                           , resolution_mult = resolution_multiplier
                           , up_pixm = up_pixm
                           , top_pixm = top_pixm
                           , down_pixm = down_pixm
                           , bottom_pixm = bottom_pixm)


for k in [ "file", "program", 'argument']:
    listBox[k].show()


for k in ["argument",  "file", "program" ]:
    QObject.connect(listBox[k], PYSIGNAL("item_pressed"), on_list_item_pressed)
    QObject.connect(listBox[k], PYSIGNAL("item_released"), on_list_item_released)

    QObject.connect(listBox[k], PYSIGNAL("item_button_pressed"), on_list_item_button_pressed)






# THIRD ROW
for k in ['argument', "file", "program"]:
    filterBox[k] = QHBox(vbox[k])
    filterBox[k].setSpacing(3) # @@ TODO: scale?

    filterClearButton[k] = QPushButton(filterBox[k])
    filterClearButton[k].show()
    filterClearButton[k].setIconSet(QIconSet(QPixmap(config.imgDir + 'delete-right.png')))
    filterClearButton[k].setSizePolicy(QSizePolicy.Fixed, QSizePolicy.Minimum)

    filterQuickText[k] = MyLineEdit(filterBox[k])
    filterQuickText[k].show()
    QObject.connect(filterQuickText[k], PYSIGNAL("timer"), onFilterKeyTimer)
    QObject.connect(filterQuickText[k], SIGNAL("returnPressed()"), onEnterPressedOnFilter)

    filterButton[k] = QPushButton(QIconSet(QPixmap(config.imgDir + "mbuto.png")),
                                  _("Recent filters"), filterBox[k])
    filterButton[k].show()

    filterMenu[k] = MyPopupMenu(filterButton[k])
    QObject.connect(filterMenu[k], PYSIGNAL("itemActivated"), onRecentFilterClicked)
    filterButton[k].setPopup(filterMenu[k])

for k in ['program', "file", 'argument']:
    filterBox[k].show()


QToolTip.add(filterClearButton['file'],
 _("This button clears the filter area to the right. This means you will see all the \nfiles that were previously hidden."))
QToolTip.add(filterClearButton['program'],
 _("This button clears the filter area to the right. This means you will see all the \nprograms that were previously hidden."))
QToolTip.add(filterClearButton['argument'],
 _("This button clears the filter area to the right. This means you will see all the \nitems that were previously hidden."))

QToolTip.add(filterQuickText['file'],
 _("This is the file filter area.\nIf you type some text here, only those files whose name \ncontains the text will be shown."))
QToolTip.add(filterQuickText['program'],
 _("This is the program filter area.\nIf you type some text here, only those programs whose name \ncontains the text will be shown."))
QToolTip.add(filterQuickText['argument'],
 _("This is the history filter area.\nIf you type some text here, only those items whose name \ncontains the text will be shown."))


QToolTip.add(filterButton['file'],
 _("Use this button to reapply a previous filter to the files list. \nFile filters typically need to be applied again and again: \nthis way you can type them only once and use them forever."))

QToolTip.add(filterButton['program'],
 _("Use this button to reapply a previous filter to the programs list."))

QToolTip.add(filterButton['argument'],
 _("You can use this button to reapply a previous filter to the history list."))

rebuildFilterMenus()
QObject.connect(filterClearButton['file'], SIGNAL("clicked()"), clearFileFiltersAndUpdate)
QObject.connect(filterClearButton['program'], SIGNAL("clicked()"), clearProgramFiltersAndUpdate)
QObject.connect(filterClearButton['argument'], SIGNAL("clicked()"), clearArgumentFiltersAndUpdate)


# FOURTH ROW

kwin_module = kdecore.KWinModule()

windows_sorted_by_creation_date = [x for x in kwin_module.windows()]
windows_sorted_by_usage = [ x for x in kwin_module.windows()] # initially they are the same
windows_sorted_by_usage.reverse()
def on_active_window_changed(w):
    global windows_sorted_by_usage
    # this is called not only when a window is made active, but
    # also when a window is closed! Only after, onWindowRemoved
    # is called! So I must not call rebuild_window_menu if the
    # window has no wid. BUG FIXED.
    if kwin_module.hasWId(w):
        windows_sorted_by_usage.remove(w)
        windows_sorted_by_usage = [w] + windows_sorted_by_usage
        if not the_window_list_has_been_deleted:
            tx = sortBox['window'].currentText()
            recent_usage = tx == _("Recent usage")
            redraw_windows(remember_scroll = not recent_usage
                           ,  reverse = last_position_of_applet == 1)
    else:
        pass
        # do nothing. on_window_removed will be called shortly, and
        # will remove the WId from the list

try:
    QObject.connect(kwin_module
                    , SIGNAL("activeWindowChanged(WId)"), on_active_window_changed)



except RuntimeError:
    pykde_supports_wid = False
    error_msg = _("Since you are running a PyKDE version prior to 3.11.3, you\nwon't be able to sort the windows by recent usage. This is a\nsubstantial limitation, so please consider upgrading your \nPyKDE.")

    print error_msg
    QMessageBox.critical(mainVBox, _("OneFinger - Non critical error"), error_msg)

    # BEGIN fix the PyKDE bug with a polling
    window_timer = QTimer(mainVBox)
    def on_window_timer():
        global windows_sorted_by_creation_date
        windows_sorted_by_creation_date = kwin_module.windows()
        if not the_window_list_has_been_deleted:
            redraw_windows(remember_scroll = True
                           ,  reverse = last_position_of_applet == 1)
    QObject.connect(window_timer, SIGNAL("timeout()"), on_window_timer)
    window_timer.start(1000)
    # END
else:
    pykde_supports_wid = True
    def on_window_added(w):
        global windows_sorted_by_creation_date, windows_sorted_by_usage
        windows_sorted_by_usage = [w] + windows_sorted_by_usage
        windows_sorted_by_creation_date.append(w)
        if not the_window_list_has_been_deleted:
            tx = sortBox['window'].currentText()
            recent_usage = tx == _("Recent usage")
            redraw_windows(remember_scroll = not recent_usage
                           ,  reverse = last_position_of_applet == 1)

    QObject.connect(kwin_module
                    , SIGNAL("windowAdded(WId)"), on_window_added)
    def on_window_changed(w, changed_properties):
        # this updates the visible name of the window
        if changed_properties & NET.WMName: # without this, OneFinger freezes for seconds!
            if not the_window_list_has_been_deleted:
                redraw_windows(remember_scroll = True
                               ,  reverse = last_position_of_applet == 1) 
         
    def on_window_removed(w):
        global windows_sorted_by_creation_date, windows_sorted_by_usage
        windows_sorted_by_usage.remove(w)
        windows_sorted_by_creation_date.remove(w)
        if not the_window_list_has_been_deleted:
            redraw_windows(remember_scroll = False
                           ,  reverse = last_position_of_applet == 1) # don't change to not(recent_usage)

    QObject.connect(kwin_module
                    , SIGNAL("windowRemoved(WId)"), on_window_removed)

def onSortBoxItemActivated(box, item):
    print "onSortBoxItemActivated"
    global sorting_criterion_for_dir, sorting_criterion_for_programs, sorting_criterion_for_arguments
    assert item in ["Recent usage", "Frequent usage", "Date", "Name", "Size"] # sic! don't change. Don't add _().

    k = find(['program', 'file', 'argument', 'window'], lambda x: box is sortBox[x])

    if k == 'file' :
        print "setting sorting_criterion_for_dir " + cur_dir + " = " + item
        sorting_criterion_for_dir[cur_dir] = item
        redraw_files()
        listBox['file'].flash_all_items(config.gFlashingTimeForList)

    if k == 'program':
        sorting_criterion_for_programs = item
        redraw_programs(remember_scroll= False)
        listBox['program'].flash_all_items(config.gFlashingTimeForList)
    if k== 'argument':
        sorting_criterion_for_arguments = item
        redraw_history()
        listBox['argument'].flash_all_items(config.gFlashingTimeForList)

    if k == 'window':
        print "redrawing windows"
        redraw_windows(remember_scroll = False
                       ,  reverse = last_position_of_applet == 1)
        listBox['window'].flash_all_items(config.gFlashingTimeForList)


for k in ["argument", "file", "program"]:
    sortBox[k] = MyComboBox(filterBox[k])
    sortBox[k].setMinimumHeight(int(35.0 * resolution_multiplier))
    sortBox[k].insertItem(config.imgDir + "name.png", text = _("Name"), data = "Name")
    sortBox[k].insertItem(config.imgDir + "favourites-small.png", _("Frequent usage"), "Frequent usage")
    sortBox[k].insertItem(config.imgDir + "stock_timer.png", _("Recent usage"), "Recent usage")
    QObject.connect(sortBox[k], PYSIGNAL("itemActivated"), onSortBoxItemActivated)
    sortBox[k].show()




sortBox['file'].insertItem(config.imgDir + "size.png", _("Size"), "Size")
sortBox['file'].insertItem(config.imgDir + "clock-small.png", _("Date"), "Date")

sortBox['file'].setCurrentText(_(sorting_criterion_for_dir.get(cur_dir, "Recent usage")))
sortBox['program'].setCurrentText(_(sorting_criterion_for_programs))
sortBox['argument'].setCurrentText(_(sorting_criterion_for_arguments))


QToolTip.add(sortBox['argument'],
 _("You can use this button to change the way items are ordered."))
QToolTip.add(sortBox['file'],
             
 _("You can use this button to change the order with which files appear in\nthe above list. Each folder will remember this setting independently. You\nshould almost always leave the default order, \"recent usage\", but\nthere are a few exceptions: for your downloads folder, you should\nset a sorting by date, because this way you can quickly find the\nlatest downloaded file. It can also be useful to sort temporarily by\nsize, if you want to quickly find the largest file in order to burn it\nto CD. The other orderings are probably useless. In particular, sorting by name\nis useless because it's easier to use the filter box above."))


QToolTip.add(sortBox['program'],
             
_("Change the order with which programs appear in the above list. There\nis a dispute about whether ordering by recent usage is better than\nfrequent usage. Personally I prefer recent usage, because frequent\nfiles are still shown among the first items, but \"temporal\ncoherence\" is exploited as well."))
QToolTip.add(sortBox['argument'],
             _("Change the order with which items appear in the above list."))





#



def redraw_simple_command_area():

    horiz_list.clear()

    if selected_actions != []:
        assert len(selected_actions) == 1
        horiz_list.items.append( HorizListItem(
            item_icon = selected_actions[0].icon() ,
            item_text = selected_actions[0].short_name(),
            item_data = selected_actions[0]))

    for  f in selected_files:
        horiz_list.items.append( HorizListItem(item_icon = file_to_icon(f, 16) ,
                                               item_text = f,
                                               item_data = f))

    horiz_list.make_changes_visible()



#




bash_command_hbox = QHBox(command_tab_widget)
command_tab_widget.addTab(bash_command_hbox, "Shell command")

bash_command_hbox.setSpacing(spacing)
bash_command_hbox.show()

clear_bash_cmd_button = QPushButton( bash_command_hbox)
clear_bash_cmd_button.setPixmap(QPixmap(config.imgDir + "delete-right-big.png"))
clear_bash_cmd_button.setMinimumSize( int(44.0 * resolution_multiplier)
                                     , int(32.0 * resolution_multiplier))
clear_bash_cmd_button.setSizePolicy(QSizePolicy.Fixed, QSizePolicy.Minimum)
QToolTip.add(clear_bash_cmd_button,
             _("Clears the command area (to the right)."))

def on_clear_bash_cmd_button_pressed():
    global program_focused_in_history
    commandEntry.setText("")
    # BEGIN seems necessary, because it resets itself
    #commandEntry.setCurrentFont(fixed_font)
    # END
    program_focused_in_history = None
    redraw_history()
    redraw_programs(remember_scroll = True) # only to show the updated toggle buttons @@
    listBox['argument'].flash_all_items(config.gFlashingTimeForList)

    # BEGIN We must not do this: it is the job of on_text_changed to
    # refresh (and flash) the file listbox. 
    #listBox['file'].enable_all_items(False)
    #listBox['file'].update()
    #locationButton.setEnabled(False)
    #END
    

QObject.connect(clear_bash_cmd_button, SIGNAL("clicked()"), on_clear_bash_cmd_button_pressed)
clear_bash_cmd_button.setSizePolicy(QSizePolicy.Fixed, QSizePolicy.Minimum)



bash_command_vbox = QVBox(bash_command_hbox)
bash_command_vbox.show()


commandEntry = qt.QLineEdit(bash_command_vbox) # was FlashingTextEdit(bash_command_vbox)
# commandEntry.setTextFormat(Qt.PlainText)
# fixed_font = kdecore.KGlobalSettings.fixedFont()
# commandEntry.setCurrentFont(fixed_font)
# commandEntry.setWordWrap(QTextEdit.NoWrap)
# commandEntry.setSizePolicy(QSizePolicy.Minimum, QSizePolicy.Minimum)
# commandEntry.setMaximumHeight(height_of_execute_buttons)

def on_return_pressed_on_command():
    # BEGIN delete the last character, the newline
#     commandEntry.moveCursor(QTextEdit.MoveBackward, True)
#     commandEntry.delChar()
    # END
    execute(use_terminal = True)
QObject.connect(commandEntry, SIGNAL("returnPressed()"), on_return_pressed_on_command)

commandEntry.show()
commandEntry.setFocus()

QToolTip.add(commandEntry,
             
_("This is the command area. The programs, files and options  \nyou click will appear here. When you have composed a meaningful\ncommand, you can execute it via the button to the right.\nYou can also type text directly, but this is only useful \nfor typing short program names, http locations, etc."))




cwd = os.getcwd()




loader = kdecore.KIconLoader()


# exec_in_term_pix =  loader.loadIcon( "konsole"
#                                      , kdecore.KIcon.Small)
# execute_in_term_button = FlashingPushButton(QIconSet(exec_in_term_pix),
#                                         _("Execute"),
#                                         bash_command_hbox)
# execute_in_term_button.setSizePolicy(QSizePolicy.Fixed, QSizePolicy.Minimum)
# execute_in_term_button.show()
# execute_in_term_button.setMinimumHeight(exec_in_term_pix.height() + 5)
# QToolTip.add(execute_in_term_button,

# _("Open a terminal and execute the command which appears in the command area (to the left)."))



#




popup_menu_of_execute_bash_command = MyPopupMenu(mainWindow)
popup_menu_of_execute_bash_command.addItem(
    _("In terminal"),
    loader.loadIconSet( "konsole"
                          , kdecore.KIcon.Desktop
                          , size_of_big_icons_in_popup_menus * resolution_multiplier),
    item_data = "Execute in terminal")
popup_menu_of_execute_bash_command.addItem(
    _("Not in terminal"),
    loader.loadIconSet( "cache"
                          , kdecore.KIcon.Desktop
                          , size_of_big_icons_in_popup_menus * resolution_multiplier),
    item_data = "Execute discarding output")


def on_execute_bash_cmd_chosen(menu, item):
    if item == "Execute discarding output":
        execute(use_terminal = False)
    elif item == "Execute in terminal":
        execute(use_terminal = True)
    else:
        raise "not managed"
    


QObject.connect(popup_menu_of_execute_bash_command,
                PYSIGNAL("itemActivated"),
                on_execute_bash_cmd_chosen)


#

exec_pix =  loader.loadIcon( "cache"
                             , kdecore.KIcon.Small)

execute_button = FlashingPushButton(QIconSet(exec_pix)
                                    , _("Execute")
                                    , bash_command_hbox)
execute_button.setSizePolicy(QSizePolicy.Fixed, QSizePolicy.Minimum)
execute_button.show()
execute_button.setMinimumHeight(exec_pix.height() + 5)
execute_button.setMinimumWidth(150.0 * resolution_multiplier)
QToolTip.add(execute_button,
             _("Execute the text command you have composed."))

     

def on_execute_button_pressed():
    popup_menu_of_execute_bash_command.popup(qt.QCursor.pos())

QObject.connect(execute_button, SIGNAL("clicked()"), on_execute_button_pressed)






#





class failure_updating_stats:
    def __init__(self, program):
        self.program_not_recognized = program

class success_updating_stats:
    def __init__(self, program, args):
        self.p = program
        self.arguments = args


def execute(use_terminal):
    global program_focused_in_history, selected_files, files_selected_in_the_history_panel
    
    # returns either the string "ok" or a class failure_updating_stats
    def update_stats_for_cli_command(cmd, use_terminal, also_update_args_with_any_program):
        global last_usage_time_of_cli_program, usage_count_of_cli_program
        global arguments_of_cli_program, last_usage_time_of_file, usage_count_of_file
        global program_runs_in_terminal, arguments_used_with_any_program

        l = do_shell_expans_then_tokenize(cmd)
        assert(len(l)>0)

        p = string.strip(l[0]) # now p is the program, and can be a file with path too.

        if not( exists(cli_programs_installed__classes,
                       lambda x: x.name() == p)
                or
                ( os.path.isfile(p)
                  and os.access(p, os.X_OK))):

            return failure_updating_stats(p)
        else:
            time_frozen = time.gmtime()
            # BEGIN increase stats for files
            files = [f for f in l if os.path.exists(f)]
            for f in files:
                usage_count_of_file[f] = usage_count_of_file.get(f,0) +1
                last_usage_time_of_file[f] = time_frozen
            # END
            # BEGIN set statistics concerning program p
            usage_count_of_cli_program[p] = usage_count_of_cli_program.get(p, 0) +1
            last_usage_time_of_cli_program[p] = time_frozen

            if arguments_of_cli_program.get(p, None) == None:
                arguments_of_cli_program[p] = []
            arguments = l[1:]
            for a in arguments:
                fi = find(arguments_of_cli_program[p],
                          lambda pair: pair.name == a)
                if fi ==None:
                    arguments_of_cli_program[p].append(
                        argument_info(a,1, time_frozen))
                else:
                    arguments_of_cli_program[p].remove( fi)
                    arguments_of_cli_program[p].append(
                        argument_info(a, fi.usage_count +1,
                                      time_frozen))
            if use_terminal:
                program_runs_in_terminal[p] = "yes"
            else:
                program_runs_in_terminal[p] = "no"

            if  types_used_with_cli_program.get(p, None) == None:
                types_used_with_cli_program[p] = Set() # the empty set
            for f in files:
                url = kdecore.KURL()
                url.setFileName(f)

                file_item = kio.KFileItem(kio.KFileItem.Unknown
                                          , kio.KFileItem.Unknown
                                          , url)
                type = file_item.mimetype()
                types_used_with_cli_program[p].add(str(type))

            # END

            # BEGIN remember arguments used with ANY program (not
            # p)
            if also_update_args_with_any_program:
                for a in arguments:
                    fi = find(arguments_used_with_any_program,
                              lambda pair: pair.name == a)
                    if fi ==None:
                        arguments_used_with_any_program.append(
                            argument_info(a,1, time_frozen))
                    else:
                        arguments_used_with_any_program.remove( fi)
                        arguments_used_with_any_program.append(
                            argument_info(a, fi.usage_count +1,
                                          time_frozen))

            # END
            return success_updating_stats(p, arguments)



        
    cmd = str(commandEntry.text())
    res = update_stats_for_cli_command(cmd, use_terminal = use_terminal
                                       , also_update_args_with_any_program = True)
    if isinstance(res, success_updating_stats):

        rebuild_progs_that_can_manage_some_file()
        
        filterQuickText['program'].setText("")
        commandEntry.setText("")
        #commandEntry.setFamily("mono") # seems necessary, because it resets itself
        program_focused_in_history = None
        cmd = cmd 
        print cmd
        if use_terminal:
            def replace_file_with_cross(f):
                if os.path.exists(f):
                    return "X"
                else:
                    return f
            args2 = [replace_file_with_cross(a) for a in res.arguments]
            title = res.p +  reduce(lambda x, y: x + "  " + y
                                    , args2
                                    , "")
            os.system( "konsole --noclose  -T \"" + title + "\" -e " +  cmd +  " & " )
        else:
            os.system(cmd + " &")
        selected_files = []
        update_info_bar()
        files_selected_in_the_history_panel.clear()
        update_clear_simple_cmd_button()
        redraw_programs(remember_scroll = False)
        redraw_files()
        redraw_history()
        redraw_simple_command_area()

    else:
        assert isinstance(res, failure_updating_stats)
        QMessageBox.critical(mainVBox
                          , "Program not recognized"
                          , "The program \"" + res.program_not_recognized
                             + "\" has been rejected because it was not in the path, \nit was not an executable file and it was not a known built-in command.")







#



help_hbox = QHBox(mainVBox)
#help_hbox.setMargin(spacing)
help_hbox.setPaletteBackgroundColor(help_hbox.palette().active().mid())
help_hbox.setFrameStyle(QFrame.StyledPanel | QFrame.Sunken)
help_hbox.setSpacing(spacing)
if help_bar_visible:
    help_hbox.show()
else:
    help_hbox.hide()
help_label = FlashingLabel( "", help_hbox)
help_label.setAlignment(Qt.AlignRight |Qt.AlignVCenter)

update_info_bar()

hide_help_button=QPushButton( loader.loadIconSet( "cancel"
                                                  , kdecore.KIcon.Small)
                              
                              , _("Hide")
                              , help_hbox)
hide_help_button.setSizePolicy(QSizePolicy.Fixed, QSizePolicy.Minimum)
QToolTip.add(hide_help_button, _("Hides this help bar to gain more space. You will be able to activate it again \nwith a toolbar button."))
def on_hide_help():
    help_hbox.hide()
    global help_bar_visible
    help_bar_visible = False

QObject.connect(hide_help_button, SIGNAL("clicked()")
                , on_hide_help)





#




#

create_window_list()



redraw_files()
redraw_programs(remember_scroll = False)
redraw_history()


mainWindow.setCaption(cur_dir)
mainWindow.showMaximized()

if (  windowlist_x_read_from_db == None or windowlist_y_read_from_db == None
      or windowlist_wt_read_from_db == None or windowlist_ht_read_from_db == None):
    windowlist_window.hide()
else:
    windowlist_window.hide()
    # BEGIN this must be before move, otherwise the win could be resized
    windowlist_window.resize(QSize(windowlist_wt_read_from_db, windowlist_ht_read_from_db))
    # END
    windowlist_window.move(QPoint(windowlist_x_read_from_db, windowlist_y_read_from_db))

    


kdecore.KWin.setIcons(mainWindow.winId()
                      , QPixmap(config.imgDir + "onefinger.png")
                      , QPixmap( config.imgDir + "onefinger.png"))
kdecore.KWin.setIcons(windowlist_window.winId()
                      , QPixmap(config.imgDir + "onefinger.png")
                      , QPixmap( config.imgDir + "onefinger.png"))




applic.exec_loop()

save_database()

#         # BEGIN if needed, insert a third group: those programs that
#         # OneFinger does not believe to be able to open the given
#         # files

#         if len(selected_files)>0:
#             other_programs = [x for x in verbs_and_mimeprograms
#                               if is_substring_of(filt, x.name())
#                               if not ( forall(types_selected_for_prog_narrowing(),
#                                               lambda t: x.can_manage_type(t))
#                                        or x.works_with_any_file() ) ]
            
#             # BEGIN write the label for this group of programs
#             if filt != "":
#                 filter_string =  _("Containing \"") + filt + "\"; "
#             else:
#                 filter_string = ""
#             if len(types_selected_for_prog_narrowing())>0:
#                 narrowing_string = ( _("May or may not manage ")
#                                      + set_to_string(types_selected_for_prog_narrowing())
#                                      + "; ")
#             else:
#                 narrowing_string = ""
#             if not previous_empty:
#                 listBox[k].items.append(EmptySeparator( listBox[k].listArea.width()))
#             listBox[k].items.append(TextSeparator(narrowing_string
#                                                   + filter_string 
#                                                   + sorting_string
#                                                   , listBox[k].listArea.width()))

#             # END

        
#         # END


